@ECHO OFF

@ECHO Registering Marmot-AddIn for current user ...
SET MARM_CURRENT_DIR=%CD%

IF NOT EXIST "%VS90COMNTOOLS%\..\..\VC\vcvarsall.bat" (
  echo "ERROR: *** Environment variable VS90COMNTOOLS is not set!"
  echo "       *** Is VisualStudio 2008 installed?"
  pause
  exit
)

REM Copy marmot-addin-dll
SET MARMOT_ADDIN_DLL_STR="%USERPROFILE%\Documents\Visual Studio 2008\AddIns\MarmotAddin.dll,1"

IF NOT EXIST "%USERPROFILE%\Documents\Visual Studio 2008\AddIns" (
  echo Creating dir...
  mkdir "%USERPROFILE%\Documents\Visual Studio 2008\AddIns"
)

echo Copy AddIn...
copy /Y "%CD%\MarmotAddin.dll" "%USERPROFILE%\Documents\Visual Studio 2008\AddIns\"
copy /Y "%CD%\DICE_Control.ocx" "%USERPROFILE%\Documents\Visual Studio 2008\AddIns\"

regsvr32 /s "%USERPROFILE%\Documents\Visual Studio 2008\AddIns\MarmotAddin.dll"
regsvr32 /s "%USERPROFILE%\Documents\Visual Studio 2008\AddIns\DICE_Control.ocx"

echo Add registry entries
REG ADD HKCU\Software\Microsoft\VisualStudio\9.0\AddIns\MarmotAddin.Connect /v LoadBehavior /t REG_DWORD /d 0 /f
REG ADD HKCU\Software\Microsoft\VisualStudio\9.0\AddIns\MarmotAddin.Connect /v CommandLineSafe /t REG_DWORD /d 0 /f
REG ADD HKCU\Software\Microsoft\VisualStudio\9.0\AddIns\MarmotAddin.Connect /v CommandPreload /t REG_DWORD /d 1 /f
REG ADD HKCU\Software\Microsoft\VisualStudio\9.0\AddIns\MarmotAddin.Connect /v FriendlyName /t REG_SZ /d MarmotAddin /f
REG ADD HKCU\Software\Microsoft\VisualStudio\9.0\AddIns\MarmotAddin.Connect /v Description /t REG_SZ /d "MarmotAddin - tool for analysing and checking MPI-programs." /f
REG ADD HKCU\Software\Microsoft\VisualStudio\9.0\AddIns\MarmotAddin.Connect /v AboutBoxDetails /t REG_SZ /d "For more information about HLRS, see the HLRS website at http://www.HLRS.de Copyright (c) 2007 HLRS" /f
REG ADD HKCU\Software\Microsoft\VisualStudio\9.0\AddIns\MarmotAddin.Connect /v AboutBoxIcon /t REG_SZ /d %MARMOT_ADDIN_DLL_STR% /f

REM Reset Addin toolbar
cd /D "%VS90COMNTOOLS%\..\..\VC"
call vcvarsall.bat x86
devenv /ResetAddin MarmotAddin.Connect

cd /D "%MARM_CURRENT_DIR%"
SET MARM_CURRENT_DIR=

ECHO Done.
pause
