#include <mpi.h>
#include <stdio.h>
#include <string.h>
#ifdef WIN32
 // needed for gethostname
 #include <Winsock2.h>
 #pragma comment (lib, "Ws2_32.lib")
#else
 #include <unistd.h>
#endif

int main(int argc, char **argv)
{
  int rank, size, i;
  char buf[256];

  MPI_Status status;                               // Statusobjekt
  MPI_Init(&argc, &argv);                          // MPI Initialisieren
  MPI_Comm_size(MPI_COMM_WORLD, &size);            // size abfragen
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);            // rank abfragen
  if(rank==0)
  {
    for(i=1; i<size; i++)
    {
      // Nachricht von beliebigen Sender empfangen
      MPI_Recv(buf, 256, MPI_CHAR, MPI_ANY_SOURCE, 1, MPI_COMM_WORLD, &status);
      printf("From %d of %d: %s\n", status.MPI_SOURCE, size, buf);
    }
  }
  else
  {
    sprintf(buf, "Hello, World! I am a MPI Process running on ");
    gethostname(buf + strlen(buf), 100);
    // Nachricht an Prozess 0 senden
    MPI_Send(buf, 256, MPI_CHAR, 0, 1, MPI_COMM_WORLD);
  }
  MPI_Finalize();                                  // MPI beenden
  return 0;
}
