/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#define MPI_ABORT(COMM,ERR) MPI_SOURCEINFO_ABORT(COMM,__LINE__,__FILE__,ERR)
#define MPI_ADDRESS(LOCATION, ADDRESS,ERR) MPI_SOURCEINFO_ADDRESS(LOCATION, ADDRESS,__LINE__,__FILE__,ERR)
#define MPI_ALLGATHER(SENDBUF, SENDCOUNT, SENDTYPE, RECVBUF, RECVCOUNT, RECVTYPE, COMM,ERR) MPI_SOURCEINFO_ALLGATHER(SENDBUF, SENDCOUNT, SENDTYPE, RECVBUF, RECVCOUNT, RECVTYPE, COMM,__LINE__,__FILE__,ERR)
#define MPI_ALLGATHERV(SENDBUF, SENDCOUNT, SENDTYPE, RECVBUF, RECVCOUNTS, DISPLS, RECVTYPE, COMM,ERR) MPI_SOURCEINFO_ALLGATHERV(SENDBUF, SENDCOUNT, SENDTYPE, RECVBUF, RECVCOUNTS, DISPLS, RECVTYPE, COMM,__LINE__,__FILE__,ERR)
#define MPI_ALLREDUCE(SENDBUF, RECVBUF, COUNT, DATATYPE, OP, COMM,ERR) MPI_SOURCEINFO_ALLREDUCE(SENDBUF, RECVBUF, COUNT, DATATYPE, OP, COMM,__LINE__,__FILE__,ERR)
#define MPI_ALLTOALL(SENDBUF, SENDCOUNT, SENDTYPE, RECVBUF, RECVCOUNT, RECVTYPE, COMM,ERR) MPI_SOURCEINFO_ALLTOALL(SENDBUF, SENDCOUNT, SENDTYPE, RECVBUF, RECVCOUNT, RECVTYPE, COMM,__LINE__,__FILE__,ERR)
#define MPI_ALLTOALLV(SENDBUF, SENDCOUNTS, SDISPLS, SENDTYPE, RECVBUF, RECVCOUNTS, RDISPLS, RECVTYPE, COMM,ERR) MPI_SOURCEINFO_ALLTOALLV(SENDBUF, SENDCOUNTS, SDISPLS, SENDTYPE, RECVBUF, RECVCOUNTS, RDISPLS, RECVTYPE, COMM,__LINE__,__FILE__,ERR)
#define MPI_ATTR_DELETE(COMM, KEYVAL,ERR) MPI_SOURCEINFO_ATTR_DELETE(COMM, KEYVAL,__LINE__,__FILE__,ERR)
#define MPI_ATTR_GET(COMM, KEYVAL, ATTRIBUTE_VAL, FLAG,ERR) MPI_SOURCEINFO_ATTR_GET(COMM, KEYVAL, ATTRIBUTE_VAL, FLAG,__LINE__,__FILE__,ERR)
#define MPI_ATTR_PUT(COMM, KEYVAL, ATTRIBUTE_VAL,ERR) MPI_SOURCEINFO_ATTR_PUT(COMM, KEYVAL, ATTRIBUTE_VAL,__LINE__,__FILE__,ERR)
#define MPI_BARRIER(COMM ,ERR) MPI_SOURCEINFO_BARRIER(COMM ,__LINE__,__FILE__,ERR)
#define MPI_BCAST(BUFFER, COUNT, DATATYPE, ROOT, COMM ,ERR) MPI_SOURCEINFO_BCAST(BUFFER, COUNT, DATATYPE, ROOT, COMM ,__LINE__,__FILE__,ERR)
#define MPI_BSEND(BUF, COUNT, DATATYPE, DEST, TAG, COMM,ERR) MPI_SOURCEINFO_BSEND(BUF, COUNT, DATATYPE, DEST, TAG, COMM,__LINE__,__FILE__,ERR)
#define MPI_BSEND_INIT(BUF, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST,ERR) MPI_SOURCEINFO_BSEND_INIT(BUF, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST,__LINE__,__FILE__,ERR)
#define MPI_BUFFER_ATTACH( BUFFER, SIZE,ERR) MPI_SOURCEINFO_BUFFER_ATTACH( BUFFER, SIZE,__LINE__,__FILE__,ERR)
#define MPI_BUFFER_DETACH( BUFFER, SIZE,ERR) MPI_SOURCEINFO_BUFFER_DETACH( BUFFER, SIZE,__LINE__,__FILE__,ERR)
#define MPI_CANCEL(REQUEST,ERR) MPI_SOURCEINFO_CANCEL(REQUEST,__LINE__,__FILE__,ERR)
#define MPI_CART_COORDS(COMM, RANK, MAXDIMS, COORDS,ERR) MPI_SOURCEINFO_CART_COORDS(COMM, RANK, MAXDIMS, COORDS,__LINE__,__FILE__,ERR)
#define MPI_CART_CREATE(COMM_OLD, NDIMS, DIMS, PERIODS, REORDER, COMM_CART,ERR) MPI_SOURCEINFO_CART_CREATE(COMM_OLD, NDIMS, DIMS, PERIODS, REORDER, COMM_CART,__LINE__,__FILE__,ERR)
#define MPI_CART_GET(COMM, MAXDIMS, DIMS, PERIODS, COORDS,ERR) MPI_SOURCEINFO_CART_GET(COMM, MAXDIMS, DIMS, PERIODS, COORDS,__LINE__,__FILE__,ERR)
#define MPI_CART_MAP(COMM, NDIMS, DIMS, PERIODS, NEWRANK,ERR) MPI_SOURCEINFO_CART_MAP(COMM, NDIMS, DIMS, PERIODS, NEWRANK,__LINE__,__FILE__,ERR)
#define MPI_CART_RANK(COMM, COORDS, RANK,ERR) MPI_SOURCEINFO_CART_RANK(COMM, COORDS, RANK,__LINE__,__FILE__,ERR)
#define MPI_CART_SHIFT(COMM, DIRECTION, DISP, RANK_SOURCE, RANK_DEST,ERR) MPI_SOURCEINFO_CART_SHIFT(COMM, DIRECTION, DISP, RANK_SOURCE, RANK_DEST,__LINE__,__FILE__,ERR)
#define MPI_CART_SUB(COMM, REMAIN_DIMS, NEWCOMM,ERR) MPI_SOURCEINFO_CART_SUB(COMM, REMAIN_DIMS, NEWCOMM,__LINE__,__FILE__,ERR)
#define MPI_CARTDIM_GET(COMM, NDIMS,ERR) MPI_SOURCEINFO_CARTDIM_GET(COMM, NDIMS,__LINE__,__FILE__,ERR)
#define MPI_COMM_COMPARE(COMM1,COMM2,RESULT,ERR) MPI_SOURCEINFO_COMM_COMPARE(COMM1,COMM2,RESULT,__LINE__,__FILE__,ERR)
#define MPI_COMM_CREATE(COMM,GROUP,NEWCOMM,ERR) MPI_SOURCEINFO_COMM_CREATE(COMM,GROUP,NEWCOMM,__LINE__,__FILE__,ERR)
#define MPI_COMM_DUP(COMM,NEWCOMM,ERR) MPI_SOURCEINFO_COMM_DUP(COMM,NEWCOMM,__LINE__,__FILE__,ERR)
#define MPI_COMM_FREE(COMM,ERR) MPI_SOURCEINFO_COMM_FREE(COMM,__LINE__,__FILE__,ERR)
#define MPI_COMM_GROUP(COMM,GROUP,ERR) MPI_SOURCEINFO_COMM_GROUP(COMM,GROUP,__LINE__,__FILE__,ERR)
#define MPI_COMM_RANK(COMM, RANK,ERR) MPI_SOURCEINFO_COMM_RANK(COMM, RANK,__LINE__,__FILE__,ERR)
#define MPI_COMM_REMOTE_GROUP(COMM, GROUP,ERR) MPI_SOURCEINFO_COMM_REMOTE_GROUP(COMM, GROUP,__LINE__,__FILE__,ERR)
#define MPI_COMM_REMOTE_SIZE(COMM, SIZE,ERR) MPI_SOURCEINFO_COMM_REMOTE_SIZE(COMM, SIZE,__LINE__,__FILE__,ERR)
#define MPI_COMM_SIZE(COMM, SIZE,ERR) MPI_SOURCEINFO_COMM_SIZE(COMM, SIZE,__LINE__,__FILE__,ERR)
#define MPI_COMM_SPLIT(COMM, COLOR, KEY, NEWCOMM,ERR) MPI_SOURCEINFO_COMM_SPLIT(COMM, COLOR, KEY, NEWCOMM,__LINE__,__FILE__,ERR)
#define MPI_COMM_TEST_INTER(COMM, FLAG,ERR) MPI_SOURCEINFO_COMM_TEST_INTER(COMM, FLAG,__LINE__,__FILE__,ERR)
#define MPI_DIMS_CREATE(NNODES,NDIMS,DIMS,ERR) MPI_SOURCEINFO_DIMS_CREATE(NNODES,NDIMS,DIMS,__LINE__,__FILE__,ERR)
#define MPI_ERRHANDLER_CREATE(FUNCTION,ERRHANDLER,ERR) MPI_SOURCEINFO_ERRHANDLER_CREATE(FUNCTION,ERRHANDLER,__LINE__,__FILE__,ERR)
#define MPI_ERRHANDLER_FREE(ERRHANDLER,ERR) MPI_SOURCEINFO_ERRHANDLER_FREE(ERRHANDLER,__LINE__,__FILE__,ERR)
#define MPI_ERRHANDLER_GET(COMM,ERRHANDLER,ERR) MPI_SOURCEINFO_ERRHANDLER_GET(COMM,ERRHANDLER,__LINE__,__FILE__,ERR)
#define MPI_ERRHANDLER_SET(COMM,ERRHANDLER,ERR) MPI_SOURCEINFO_ERRHANDLER_SET(COMM,ERRHANDLER,__LINE__,__FILE__,ERR)
#define MPI_ERROR_CLASS(ERRORCODE,ERRORCLASS,ERR) MPI_SOURCEINFO_ERROR_CLASS(ERRORCODE,ERRORCLASS,__LINE__,__FILE__,ERR)
#define MPI_ERROR_STRING(ERRORCODE,STRING,RESULTLEN,ERR) MPI_SOURCEINFO_ERROR_STRING(ERRORCODE,STRING,RESULTLEN,__LINE__,__FILE__,ERR)
#define MPI_FINALIZE(ERR) MPI_SOURCEINFO_FINALIZE(__LINE__,__FILE__,ERR)
#define MPI_GATHER(SENDBUF,SENDCOUNT,SENDTYPE,RECVBUF,RECVCOUNT,RECVTYPE,ROOT,COMM,ERR) MPI_SOURCEINFO_GATHER(SENDBUF,SENDCOUNT,SENDTYPE,RECVBUF,RECVCOUNT,RECVTYPE,ROOT,COMM,__LINE__,__FILE__,ERR)
#define MPI_GATHERV(SENDBUF,SENDCOUNT,SENDTYPE,RECVBUF,RECVCOUNTS,DISPLS,RECVTYPE,ROOT,COMM,ERR) MPI_SOURCEINFO_GATHERV(SENDBUF,SENDCOUNT,SENDTYPE,RECVBUF,RECVCOUNTS,DISPLS,RECVTYPE,ROOT,COMM,__LINE__,__FILE__,ERR)
#define MPI_GET_COUNT(STATUS,DATATYPE,COUNT,ERR) MPI_SOURCEINFO_GET_COUNT(STATUS,DATATYPE,COUNT,__LINE__,__FILE__,ERR)
#define MPI_GET_ELEMENTS(STATUS,DATATYPE,COUNT,ERR) MPI_SOURCEINFO_GET_ELEMENTS(STATUS,DATATYPE,COUNT,__LINE__,__FILE__,ERR)
#define MPI_GET_PROCESSOR_NAME(NAME,RESULTLEN,ERR) MPI_SOURCEINFO_GET_PROCESSOR_NAME(NAME,RESULTLEN,__LINE__,__FILE__,ERR)
#define MPI_GET_VERSION(VERSION,SUBVERSION,ERR) MPI_SOURCEINFO_GET_VERSION(VERSION,SUBVERSION,__LINE__,__FILE__,ERR)
#define MPI_GRAPH_CREATE(COMM_OLD,NNODES,INDEX,EDGES,REORDER,COMM_GRAPH,ERR) MPI_SOURCEINFO_GRAPH_CREATE(COMM_OLD,NNODES,INDEX,EDGES,REORDER,COMM_GRAPH,__LINE__,__FILE__,ERR)
#define MPI_GRAPH_GET(COMM,MAXINDEX,MAXEDGES,INDEX,EDGES,ERR) MPI_SOURCEINFO_GRAPH_GET(COMM,MAXINDEX,MAXEDGES,INDEX,EDGES,__LINE__,__FILE__,ERR)
#define MPI_GRAPH_MAP(COMM,NNODES,INDEX,EDGES,NEWRANK,ERR) MPI_SOURCEINFO_GRAPH_MAP(COMM,NNODES,INDEX,EDGES,NEWRANK,__LINE__,__FILE__,ERR)
#define MPI_GRAPH_NEIGHBORS(COMM,RANK,MAXNEIGHBORS,NEIGHBORS,ERR) MPI_SOURCEINFO_GRAPH_NEIGHBORS(COMM,RANK,MAXNEIGHBORS,NEIGHBORS,__LINE__,__FILE__,ERR)
#define MPI_GRAPH_NEIGHBORS_COUNT(COMM,RANK,NNEIGHBORS,ERR) MPI_SOURCEINFO_GRAPH_NEIGHBORS_COUNT(COMM,RANK,NNEIGHBORS,__LINE__,__FILE__,ERR)
#define MPI_GRAPHDIMS_GET(COMM,NNODES,NEDGES,ERR) MPI_SOURCEINFO_GRAPHDIMS_GET(COMM,NNODES,NEDGES,__LINE__,__FILE__,ERR)
#define MPI_GROUP_COMPARE(GROUP1,GROUP2,RESULT,ERR) MPI_SOURCEINFO_GROUP_COMPARE(GROUP1,GROUP2,RESULT,__LINE__,__FILE__,ERR)
#define MPI_GROUP_DIFFERENCE(GROUP1,GROUP2,NEWGROUP,ERR) MPI_SOURCEINFO_GROUP_DIFFERENCE(GROUP1,GROUP2,NEWGROUP,__LINE__,__FILE__,ERR)
#define MPI_GROUP_EXCL(GROUP,N,RANKS,NEWGROUP,ERR) MPI_SOURCEINFO_GROUP_EXCL(GROUP,N,RANKS,NEWGROUP,__LINE__,__FILE__,ERR)
#define MPI_GROUP_FREE(GROUP,ERR) MPI_SOURCEINFO_GROUP_FREE(GROUP,__LINE__,__FILE__,ERR)
#define MPI_GROUP_INCL(GROUP,N,RANKS,NEWGROUP,ERR) MPI_SOURCEINFO_GROUP_INCL(GROUP,N,RANKS,NEWGROUP,__LINE__,__FILE__,ERR)
#define MPI_GROUP_INTERSECTION(GROUP1,GROUP2,NEWGROUP,ERR) MPI_SOURCEINFO_GROUP_INTERSECTION(GROUP1,GROUP2,NEWGROUP,__LINE__,__FILE__,ERR)
#define MPI_GROUP_RANK(GROUP,RANK,ERR) MPI_SOURCEINFO_GROUP_RANK(GROUP,RANK,__LINE__,__FILE__,ERR)
#define MPI_GROUP_SIZE(GROUP,SIZE,ERR) MPI_SOURCEINFO_GROUP_SIZE(GROUP,SIZE,__LINE__,__FILE__,ERR)
#define MPI_GROUP_TRANSLATE_RANKS(GROUP1,N,RANKS1,GROUP2,RANKS2,ERR) MPI_SOURCEINFO_GROUP_TRANSLATE_RANKS(GROUP1,N,RANKS1,GROUP2,RANKS2,__LINE__,__FILE__,ERR)
#define MPI_GROUP_UNION(GROUP1,GROUP2,NEWGROUP,ERR) MPI_SOURCEINFO_GROUP_UNION(GROUP1,GROUP2,NEWGROUP,__LINE__,__FILE__,ERR)
#define MPI_IBSEND(BUF,COUNT,DATATYPE,DEST,TAG,COMM,REQUEST,ERR) MPI_SOURCEINFO_IBSEND(BUF,COUNT,DATATYPE,DEST,TAG,COMM,REQUEST,__LINE__,__FILE__,ERR)
#define MPI_INIT(ERR) MPI_SOURCEINFO_INIT(__LINE__,__FILE__,ERR)
#define MPI_INITIALIZED(FLAG,ERR) MPI_SOURCEINFO_INITIALIZED(FLAG,__LINE__,__FILE__,ERR)
#define MPI_INTERCOMM_CREATE(LOCAL_COMM,LOCAL_LEADER,PEER_COMM,REMOTE_LEADER,TAG,NEWINTERCOMM,ERR) MPI_SOURCEINFO_INTERCOMM_CREATE(LOCAL_COMM,LOCAL_LEADER,PEER_COMM,REMOTE_LEADER,TAG,NEWINTERCOMM,__LINE__,__FILE__,ERR)
#define MPI_INTERCOMM_MERGE(INTERCOMM,HIGH,NEWINTRACOMM,ERR) MPI_SOURCEINFO_INTERCOMM_MERGE(INTERCOMM,HIGH,NEWINTRACOMM,__LINE__,__FILE__,ERR)
#define MPI_IPROBE(SOURCE,TAG,COMM,FLAG,STATUS,ERR) MPI_SOURCEINFO_IPROBE(SOURCE,TAG,COMM,FLAG,STATUS,__LINE__,__FILE__,ERR)
#define MPI_IRECV(BUF,COUNT,DATATYPE,SOURCE,TAG,COMM,REQUEST,ERR) MPI_SOURCEINFO_IRECV(BUF,COUNT,DATATYPE,SOURCE,TAG,COMM,REQUEST,__LINE__,__FILE__,ERR)
#define MPI_IRSEND(BUF, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST,ERR) MPI_SOURCEINFO_IRSEND(BUF, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST,__LINE__,__FILE__,ERR)
#define MPI_ISEND(BUF, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST,ERR) MPI_SOURCEINFO_ISEND(BUF, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST,__LINE__,__FILE__,ERR)
#define MPI_ISSEND(BUF, COUNT,  DATATYPE, DEST, TAG, COMM, REQUEST,ERR) MPI_SOURCEINFO_ISSEND(BUF, COUNT,  DATATYPE, DEST, TAG, COMM, REQUEST,__LINE__,__FILE__,ERR)
#define MPI_KEYVAL_CREATE(COPY_FN, DELETE_FN, KEYVAL, EXTRA_STATE,ERR) MPI_SOURCEINFO_KEYVAL_CREATE(COPY_FN, DELETE_FN, KEYVAL, EXTRA_STATE,__LINE__,__FILE__,ERR)
#define MPI_KEYVAL_FREE(KEYVAL,ERR) MPI_SOURCEINFO_KEYVAL_FREE(KEYVAL,__LINE__,__FILE__,ERR)
#define MPI_OP_CREATE(FUNCTION, COMMUTE, OP,ERR) MPI_SOURCEINFO_OP_CREATE(FUNCTION, COMMUTE, OP,__LINE__,__FILE__,ERR)
#define MPI_OP_FREE( OP,ERR) MPI_SOURCEINFO_OP_FREE( OP,__LINE__,__FILE__,ERR)
#define MPI_PACK(INBUF, INCOUNT, DATATYPE, OUTBUF, OUTSIZE, POSITION, COMM,ERR) MPI_SOURCEINFO_PACK(INBUF, INCOUNT, DATATYPE, OUTBUF, OUTSIZE, POSITION, COMM,__LINE__,__FILE__,ERR)
#define MPI_PACK_SIZE(INCOUNT,DATATYPE,COMM,SIZE,ERR) MPI_SOURCEINFO_PACK_SIZE(INCOUNT,DATATYPE,COMM,SIZE,__LINE__,__FILE__,ERR)
#define MPI_PCONTROL(LEVEL, OTHERS,ERR) MPI_SOURCEINFO_PCONTROL(LEVEL,__LINE__,__FILE__, OTHERS,ERR)
#define MPI_PROBE(SOURCE,TAG,COMM, STATUS,ERR) MPI_SOURCEINFO_PROBE(SOURCE,TAG,COMM, STATUS,__LINE__,__FILE__,ERR)
#define MPI_RECV(BUF,COUNT,DATATYPE,SOURCE,TAG,COMM,STATUS,ERR) MPI_SOURCEINFO_RECV(BUF,COUNT,DATATYPE,SOURCE,TAG,COMM,STATUS,__LINE__,__FILE__,ERR)
#define MPI_RECV_INIT(BUF,COUNT,DATATYPE,SOURCE,TAG, COMM,REQUEST,ERR) MPI_SOURCEINFO_RECV_INIT(BUF,COUNT,DATATYPE,SOURCE,TAG, COMM,REQUEST,__LINE__,__FILE__,ERR)
#define MPI_REDUCE(SENDBUF,RECVBUF,COUNT,DATATYPE, OP,ROOT,COMM,ERR) MPI_SOURCEINFO_REDUCE(SENDBUF,RECVBUF,COUNT,DATATYPE, OP,ROOT,COMM,__LINE__,__FILE__,ERR)
#define MPI_REDUCE_SCATTER(SENDBUF,RECVBUF,RECVCOUNTS,DATATYPE,OP,COMM,ERR) MPI_SOURCEINFO_REDUCE_SCATTER(SENDBUF,RECVBUF,RECVCOUNTS,DATATYPE,OP,COMM,__LINE__,__FILE__,ERR)
#define MPI_REQUEST_FREE(REQUEST,ERR) MPI_SOURCEINFO_REQUEST_FREE(REQUEST,__LINE__,__FILE__,ERR)
#define MPI_RSEND(BUF,COUNT, DATATYPE,DEST,TAG,COMM,ERR) MPI_SOURCEINFO_RSEND(BUF,COUNT, DATATYPE,DEST,TAG,COMM,__LINE__,__FILE__,ERR)
#define MPI_RSEND_INIT(BUF,COUNT,DATATYPE,DEST,TAG, COMM,REQUEST,ERR) MPI_SOURCEINFO_RSEND_INIT(BUF,COUNT,DATATYPE,DEST,TAG, COMM,REQUEST,__LINE__,__FILE__,ERR)
#define MPI_SCAN(SENDBUF,RECVBUF,COUNT, DATATYPE, OP, COMM ,ERR) MPI_SOURCEINFO_SCAN(SENDBUF,RECVBUF,COUNT, DATATYPE, OP, COMM ,__LINE__,__FILE__,ERR)
#define MPI_SCATTER(SENDBUF, SENDCOUNT, SENDTYPE, RECVBUF, RECVCOUNT, RECVTYPE, ROOT, COMM,ERR) MPI_SOURCEINFO_SCATTER(SENDBUF, SENDCOUNT, SENDTYPE, RECVBUF, RECVCOUNT, RECVTYPE, ROOT, COMM,__LINE__,__FILE__,ERR)
#define MPI_SCATTERV(SENDBUF,SENDCOUNTS,DISPLS, SENDTYPE, RECVBUF, RECVCOUNT, RECVTYPE, ROOT, COMM,ERR) MPI_SOURCEINFO_SCATTERV(SENDBUF,SENDCOUNTS,DISPLS, SENDTYPE, RECVBUF, RECVCOUNT, RECVTYPE, ROOT, COMM,__LINE__,__FILE__,ERR)
#define MPI_SEND(BUF, COUNT,DATATYPE, DEST, TAG, COMM,ERR) MPI_SOURCEINFO_SEND(BUF, COUNT,DATATYPE, DEST, TAG, COMM,__LINE__,__FILE__,ERR)
#define MPI_SEND_INIT(BUF, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST,ERR) MPI_SOURCEINFO_SEND_INIT(BUF, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST,__LINE__,__FILE__,ERR)
#define MPI_SENDRECV(SENDBUF, SENDCOUNT, SENDTYPE, DEST, SENDTAG, RECVBUF, RECVCOUNT, RECVTYPE, SOURCE, RECVTAG, COMM, STATUS,ERR) MPI_SOURCEINFO_SENDRECV(SENDBUF, SENDCOUNT, SENDTYPE, DEST, SENDTAG, RECVBUF, RECVCOUNT, RECVTYPE, SOURCE, RECVTAG, COMM, STATUS,__LINE__,__FILE__,ERR)
#define MPI_SENDRECV_REPLACE(BUF,COUNT, DATATYPE, DEST, SENDTAG, SOURCE, RECVTAG, COMM, STATUS,ERR) MPI_SOURCEINFO_SENDRECV_REPLACE(BUF,COUNT, DATATYPE, DEST, SENDTAG, SOURCE, RECVTAG, COMM, STATUS,__LINE__,__FILE__,ERR)
#define MPI_SSEND(BUF, COUNT, DATATYPE, DEST, TAG, COMM,ERR) MPI_SOURCEINFO_SSEND(BUF, COUNT, DATATYPE, DEST, TAG, COMM,__LINE__,__FILE__,ERR)
#define MPI_SSEND_INIT(BUF,COUNT,DATATYPE,DEST,TAG,COMM,REQUEST,ERR) MPI_SOURCEINFO_SSEND_INIT(BUF,COUNT,DATATYPE,DEST,TAG,COMM,REQUEST,__LINE__,__FILE__,ERR)
#define MPI_START(REQUEST,ERR) MPI_SOURCEINFO_START(REQUEST,__LINE__,__FILE__,ERR)
#define MPI_STARTALL(COUNT,ARRAY_OF_REQUESTS,ERR) MPI_SOURCEINFO_STARTALL(COUNT,ARRAY_OF_REQUESTS,__LINE__,__FILE__,ERR)
#define MPI_TEST(REQUEST, FLAG, STATUS,ERR) MPI_SOURCEINFO_TEST(REQUEST, FLAG, STATUS,__LINE__,__FILE__,ERR)
#define MPI_TEST_CANCELLED(STATUS, FLAG,ERR) MPI_SOURCEINFO_TEST_CANCELLED(STATUS, FLAG,__LINE__,__FILE__,ERR)
#define MPI_TESTALL(COUNT, ARRAY_OF_REQUESTS, FLAG, ARRAY_OF_STATUSES,ERR) MPI_SOURCEINFO_TESTALL(COUNT, ARRAY_OF_REQUESTS, FLAG, ARRAY_OF_STATUSES,__LINE__,__FILE__,ERR)
#define MPI_TESTANY(COUNT, ARRAY_OF_REQUESTS, INDEX, FLAG, STATUS,ERR) MPI_SOURCEINFO_TESTANY(COUNT, ARRAY_OF_REQUESTS, INDEX, FLAG, STATUS,__LINE__,__FILE__,ERR)
#define MPI_TESTSOME(INCOUNT, ARRAY_OF_REQUESTS, OUTCOUNT, ARRAY_OF_INDICES, ARRAY_OF_STATUSES,ERR) MPI_SOURCEINFO_TESTSOME(INCOUNT, ARRAY_OF_REQUESTS, OUTCOUNT, ARRAY_OF_INDICES, ARRAY_OF_STATUSES,__LINE__,__FILE__,ERR)
#define MPI_TOPO_TEST(COMM, STATUS,ERR) MPI_SOURCEINFO_TOPO_TEST(COMM, STATUS,__LINE__,__FILE__,ERR)
#define MPI_TYPE_COMMIT(DATATYPE,ERR) MPI_SOURCEINFO_TYPE_COMMIT(DATATYPE,__LINE__,__FILE__,ERR)
#define MPI_TYPE_CONTIGUOUS(COUNT,OLDTYPE,NEWTYPE,ERR) MPI_SOURCEINFO_TYPE_CONTIGUOUS(COUNT,OLDTYPE,NEWTYPE,__LINE__,__FILE__,ERR)
#define MPI_TYPE_EXTENT(DATATYPE,EXTENT,ERR) MPI_SOURCEINFO_TYPE_EXTENT(DATATYPE,EXTENT,__LINE__,__FILE__,ERR)
#define MPI_TYPE_FREE(DATATYPE,ERR) MPI_SOURCEINFO_TYPE_FREE(DATATYPE,__LINE__,__FILE__,ERR)
#define MPI_TYPE_HINDEXED(COUNT, ARRAY_OF_BLOCKLENGTHS, ARRAY_OF_DISPLACEMENTS, OLDTYPE, NEWTYPE,ERR) MPI_SOURCEINFO_TYPE_HINDEXED(COUNT, ARRAY_OF_BLOCKLENGTHS, ARRAY_OF_DISPLACEMENTS, OLDTYPE, NEWTYPE,__LINE__,__FILE__,ERR)
#define MPI_TYPE_HVECTOR(COUNT, BLOCKLENGTH, STRIDE, OLDTYPE, NEWTYPE,ERR) MPI_SOURCEINFO_TYPE_HVECTOR(COUNT, BLOCKLENGTH, STRIDE, OLDTYPE, NEWTYPE,__LINE__,__FILE__,ERR)
#define MPI_TYPE_INDEXED(COUNT, ARRAY_OF_BLOCKLENGTHS, ARRAY_OF_DISPLACEMENTS, OLDTYPE, NEWTYPE,ERR) MPI_SOURCEINFO_TYPE_INDEXED(COUNT, ARRAY_OF_BLOCKLENGTHS, ARRAY_OF_DISPLACEMENTS, OLDTYPE, NEWTYPE,__LINE__,__FILE__,ERR)
#define MPI_TYPE_LB(DATATYPE, DISPLACEMENT,ERR) MPI_SOURCEINFO_TYPE_LB(DATATYPE, DISPLACEMENT,__LINE__,__FILE__,ERR)
#define MPI_TYPE_SIZE(DATATYPE,SIZE,ERR) MPI_SOURCEINFO_TYPE_SIZE(DATATYPE,SIZE,__LINE__,__FILE__,ERR)
#define MPI_TYPE_STRUCT(COUNT, ARRAY_OF_BLOCKLENGTHS,ARRAY_OF_DISPLACEMENTS, ARRAY_OF_TYPES, NEWTYPE,ERR) MPI_SOURCEINFO_TYPE_STRUCT(COUNT, ARRAY_OF_BLOCKLENGTHS,ARRAY_OF_DISPLACEMENTS, ARRAY_OF_TYPES, NEWTYPE,__LINE__,__FILE__,ERR)
#define MPI_TYPE_UB(DATATYPE,DISPLACEMENT,ERR) MPI_SOURCEINFO_TYPE_UB(DATATYPE,DISPLACEMENT,__LINE__,__FILE__,ERR)
#define MPI_TYPE_VECTOR(COUNT, BLOCKLENGTH, STRIDE, OLDTYPE, NEWTYPE,ERR) MPI_SOURCEINFO_TYPE_VECTOR(COUNT, BLOCKLENGTH, STRIDE, OLDTYPE, NEWTYPE,__LINE__,__FILE__,ERR)
#define MPI_UNPACK(INBUF, INSIZE, POSITION, OUTBUF, OUTCOUNT, DATATYPE,COMM,ERR) MPI_SOURCEINFO_UNPACK(INBUF, INSIZE, POSITION, OUTBUF, OUTCOUNT, DATATYPE,COMM,__LINE__,__FILE__,ERR)
#define MPI_WAIT(REQUEST, STATUS,ERR) MPI_SOURCEINFO_WAIT(REQUEST, STATUS,__LINE__,__FILE__,ERR)
#define MPI_WAITALL(COUNT, ARRAY_OF_REQUESTS, ARRAY_OF_STATUSES,ERR) MPI_SOURCEINFO_WAITALL(COUNT, ARRAY_OF_REQUESTS, ARRAY_OF_STATUSES,__LINE__,__FILE__,ERR)
#define MPI_WAITANY(COUNT, ARRAY_OF_REQUESTS, INDEX, STATUS,ERR) MPI_SOURCEINFO_WAITANY(COUNT, ARRAY_OF_REQUESTS, INDEX, STATUS,__LINE__,__FILE__,ERR)
#define MPI_WAITSOME(INCOUNT,ARRAY_OF_REQUESTS, OUTCOUNT,ARRAY_OF_INDICES, ARRAY_OF_STATUSES,ERR) MPI_SOURCEINFO_WAITSOME(INCOUNT,ARRAY_OF_REQUESTS, OUTCOUNT,ARRAY_OF_INDICES, ARRAY_OF_STATUSES,__LINE__,__FILE__,ERR)

#define MPI_ACCUMULATE( ORIGIN_ADDR, ORIGIN_COUNT, ORIGIN_DATATYPE, TARGET_RANK, TARGET_DISP, TARGET_COUNT, TARGET_DATATYPE, OP, WIN, ERR, ERR) MPI_SOURCEINFO_ACCUMULATE( ORIGIN_ADDR, ORIGIN_COUNT, ORIGIN_DATATYPE, TARGET_RANK, TARGET_DISP, TARGET_COUNT, TARGET_DATATYPE, OP, WIN,__LINE__,__FILE__, ERR, ERR)
#define MPI_GET( ORIGIN_ADDR, ORIGIN_COUNT, ORIGIN_DATATYPE, TARGET_RANK, TARGET_DISP, TARGET_COUNT, TARGET_DATATYPE, WIN, ERR) MPI_SOURCEINFO_GET( ORIGIN_ADDR, ORIGIN_COUNT, ORIGIN_DATATYPE, TARGET_RANK, TARGET_DISP, TARGET_COUNT, TARGET_DATATYPE, WIN,__LINE__,__FILE__, ERR)
#define MPI_PUT( ORIGIN_ADDR, ORIGIN_COUNT, ORIGIN_DATATYPE, TARGET_RANK, TARGET_DISP, TARGET_COUNT, TARGET_DATATYPE, WIN, ERR) MPI_SOURCEINFO_PUT( ORIGIN_ADDR, ORIGIN_COUNT, ORIGIN_DATATYPE, TARGET_RANK, TARGET_DISP, TARGET_COUNT, TARGET_DATATYPE, WIN,__LINE__,__FILE__, ERR)
#define MPI_WIN_COMPLETE( WIN, ERR) MPI_SOURCEINFO_WIN_COMPLETE( WIN,__LINE__,__FILE__, ERR)
#define MPI_WIN_CREATE( BASE, SIZE, DISP_UNIT, INFO, COMM, WIN_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_WIN_CREATE( BASE, SIZE, DISP_UNIT, INFO, COMM, WIN_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_WIN_FENCE( ASSERT, WIN, ERR) MPI_SOURCEINFO_WIN_FENCE( ASSERT, WIN,__LINE__,__FILE__, ERR)
#define MPI_WIN_FREE( WIN_CLASS_SINGLE_IO, ERR) MPI_SOURCEINFO_WIN_FREE( WIN_CLASS_SINGLE_IO,__LINE__,__FILE__, ERR)
#define MPI_WIN_LOCK( LOCK_TYPE, RANK, ASSERT, WIN, ERR) MPI_SOURCEINFO_WIN_LOCK( LOCK_TYPE, RANK, ASSERT, WIN,__LINE__,__FILE__, ERR)
#define MPI_WIN_POST( GROUP, ASSERT, WIN, ERR) MPI_SOURCEINFO_WIN_POST( GROUP, ASSERT, WIN,__LINE__,__FILE__, ERR)
#define MPI_WIN_START( GROUP, ASSERT, WIN, ERR) MPI_SOURCEINFO_WIN_START( GROUP, ASSERT, WIN,__LINE__,__FILE__, ERR)
#define MPI_WIN_TEST( WIN, FLAG, ERR) MPI_SOURCEINFO_WIN_TEST( WIN, FLAG,__LINE__,__FILE__, ERR)
#define MPI_WIN_UNLOCK( RANK, WIN, ERR) MPI_SOURCEINFO_WIN_UNLOCK( RANK, WIN,__LINE__,__FILE__, ERR)
#define MPI_WIN_WAIT( WIN, ERR) MPI_SOURCEINFO_WIN_WAIT( WIN,__LINE__,__FILE__, ERR)

#define MPI_ALLTOALLW( SENDBUF, SENDCOUNTS, SDISPLS, SENDTYPES_CLASS_ARRAY_IN_SENDCOUNTS, RECVBUF, RECVCOUNTS, RDISPLS, RECVTYPES_CLASS_ARRAY_IN_RECVCOUNTS, COMM, ERR) MPI_SOURCEINFO_ALLTOALLW( SENDBUF, SENDCOUNTS, SDISPLS, SENDTYPES_CLASS_ARRAY_IN_SENDCOUNTS, RECVBUF, RECVCOUNTS, RDISPLS, RECVTYPES_CLASS_ARRAY_IN_RECVCOUNTS, COMM,__LINE__,__FILE__, ERR)
#define MPI_EXSCAN( SENDBUF, RECVBUF, COUNT, DATATYPE, OP, COMM, ERR) MPI_SOURCEINFO_EXSCAN( SENDBUF, RECVBUF, COUNT, DATATYPE, OP, COMM,__LINE__,__FILE__, ERR)

#define MPI_FILE_OPEN( COMM, FILENAME_CLASS_SINGLE_IN, AMODE, INFO, FH_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_OPEN( COMM, FILENAME_CLASS_SINGLE_IN, AMODE, INFO, FH_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_CLOSE( FH_CLASS_SINGLE_IO, ERR) MPI_SOURCEINFO_FILE_CLOSE( FH_CLASS_SINGLE_IO,__LINE__,__FILE__, ERR)
#define MPI_FILE_DELETE( FILENAME_CLASS_SINGLE_IN, INFO, ERR) MPI_SOURCEINFO_FILE_DELETE( FILENAME_CLASS_SINGLE_IN, INFO,__LINE__,__FILE__, ERR)
#define MPI_FILE_SET_SIZE( FH, SIZE, ERR) MPI_SOURCEINFO_FILE_SET_SIZE( FH, SIZE,__LINE__,__FILE__, ERR)
#define MPI_FILE_PREALLOCATE( FH, SIZE, ERR) MPI_SOURCEINFO_FILE_PREALLOCATE( FH, SIZE,__LINE__,__FILE__, ERR)
#define MPI_FILE_GET_SIZE( FH, SIZE_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_GET_SIZE( FH, SIZE_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_GET_GROUP( FH, GROUP_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_GET_GROUP( FH, GROUP_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_GET_AMODE( FH, AMODE, ERR) MPI_SOURCEINFO_FILE_GET_AMODE( FH, AMODE,__LINE__,__FILE__, ERR)
#define MPI_FILE_SET_INFO( FH, INFO, ERR) MPI_SOURCEINFO_FILE_SET_INFO( FH, INFO,__LINE__,__FILE__, ERR)
#define MPI_FILE_GET_INFO( FH, INFO_USED_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_GET_INFO( FH, INFO_USED_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_SET_VIEW( FH, DISP, ETYPE, FILETYPE, DATAREP_CLASS_SINGLE_IN, INFO, ERR) MPI_SOURCEINFO_FILE_SET_VIEW( FH, DISP, ETYPE, FILETYPE, DATAREP_CLASS_SINGLE_IN, INFO,__LINE__,__FILE__, ERR)
#define MPI_FILE_GET_VIEW( FH, DISP_CLASS_SINGLE_OUT, ETYPE_CLASS_SINGLE_OUT, FILETYPE_CLASS_SINGLE_OUT, DATAREP_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_GET_VIEW( FH, DISP_CLASS_SINGLE_OUT, ETYPE_CLASS_SINGLE_OUT, FILETYPE_CLASS_SINGLE_OUT, DATAREP_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_READ_AT( FH, OFFSET, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_READ_AT( FH, OFFSET, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_READ_AT_ALL( FH, OFFSET, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_READ_AT_ALL( FH, OFFSET, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_WRITE_AT( FH, OFFSET, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_WRITE_AT( FH, OFFSET, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_WRITE_AT_ALL( FH, OFFSET, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_WRITE_AT_ALL( FH, OFFSET, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_IREAD_AT( FH, OFFSET, BUF, COUNT, DATATYPE, REQUEST_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_IREAD_AT( FH, OFFSET, BUF, COUNT, DATATYPE, REQUEST_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_IWRITE_AT( FH, OFFSET, BUF, COUNT, DATATYPE, REQUEST_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_IWRITE_AT( FH, OFFSET, BUF, COUNT, DATATYPE, REQUEST_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_READ( FH, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_READ( FH, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_READ_ALL( FH, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_READ_ALL( FH, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_WRITE( FH, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_WRITE( FH, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_WRITE_ALL( FH, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_WRITE_ALL( FH, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_IREAD( FH, BUF, COUNT, DATATYPE, REQUEST_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_IREAD( FH, BUF, COUNT, DATATYPE, REQUEST_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_IWRITE( FH, BUF, COUNT, DATATYPE, REQUEST_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_IWRITE( FH, BUF, COUNT, DATATYPE, REQUEST_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_SEEK( FH, OFFSET, WHENCE, ERR) MPI_SOURCEINFO_FILE_SEEK( FH, OFFSET, WHENCE,__LINE__,__FILE__, ERR)
#define MPI_FILE_GET_POSITION( FH, OFFSET_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_GET_POSITION( FH, OFFSET_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_GET_BYTE_OFFSET( FH, OFFSET, DISP_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_GET_BYTE_OFFSET( FH, OFFSET, DISP_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_READ_SHARED( FH, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_READ_SHARED( FH, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_WRITE_SHARED( FH, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_WRITE_SHARED( FH, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_IREAD_SHARED( FH, BUF, COUNT, DATATYPE, REQUEST_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_IREAD_SHARED( FH, BUF, COUNT, DATATYPE, REQUEST_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_IWRITE_SHARED( FH, BUF, COUNT, DATATYPE, REQUEST_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_IWRITE_SHARED( FH, BUF, COUNT, DATATYPE, REQUEST_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_READ_ORDERED( FH, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_READ_ORDERED( FH, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_WRITE_ORDERED( FH, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_WRITE_ORDERED( FH, BUF, COUNT, DATATYPE, STATUS_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_SEEK_SHARED( FH, OFFSET, WHENCE, ERR) MPI_SOURCEINFO_FILE_SEEK_SHARED( FH, OFFSET, WHENCE,__LINE__,__FILE__, ERR)
#define MPI_FILE_GET_POSITION_SHARED( FH, OFFSET_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_GET_POSITION_SHARED( FH, OFFSET_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_READ_AT_ALL_BEGIN( FH, OFFSET, BUF, COUNT, DATATYPE, ERR) MPI_SOURCEINFO_FILE_READ_AT_ALL_BEGIN( FH, OFFSET, BUF, COUNT, DATATYPE,__LINE__,__FILE__, ERR)
#define MPI_FILE_READ_AT_ALL_END( FH, BUF, STATUS_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_READ_AT_ALL_END( FH, BUF, STATUS_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_WRITE_AT_ALL_BEGIN( FH, OFFSET, BUF, COUNT, DATATYPE, ERR) MPI_SOURCEINFO_FILE_WRITE_AT_ALL_BEGIN( FH, OFFSET, BUF, COUNT, DATATYPE,__LINE__,__FILE__, ERR)
#define MPI_FILE_WRITE_AT_ALL_END( FH, BUF, STATUS_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_WRITE_AT_ALL_END( FH, BUF, STATUS_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_READ_ALL_BEGIN( FH, BUF, COUNT, DATATYPE, ERR) MPI_SOURCEINFO_FILE_READ_ALL_BEGIN( FH, BUF, COUNT, DATATYPE,__LINE__,__FILE__, ERR)
#define MPI_FILE_READ_ALL_END( FH, BUF, STATUS_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_READ_ALL_END( FH, BUF, STATUS_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_WRITE_ALL_BEGIN( FH, BUF, COUNT, DATATYPE, ERR) MPI_SOURCEINFO_FILE_WRITE_ALL_BEGIN( FH, BUF, COUNT, DATATYPE,__LINE__,__FILE__, ERR)
#define MPI_FILE_WRITE_ALL_END( FH, BUF, STATUS_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_WRITE_ALL_END( FH, BUF, STATUS_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_READ_ORDERED_BEGIN( FH, BUF, COUNT, DATATYPE, ERR) MPI_SOURCEINFO_FILE_READ_ORDERED_BEGIN( FH, BUF, COUNT, DATATYPE,__LINE__,__FILE__, ERR)
#define MPI_FILE_READ_ORDERED_END( FH, BUF, STATUS_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_READ_ORDERED_END( FH, BUF, STATUS_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_WRITE_ORDERED_BEGIN( FH, BUF, COUNT, DATATYPE, ERR) MPI_SOURCEINFO_FILE_WRITE_ORDERED_BEGIN( FH, BUF, COUNT, DATATYPE,__LINE__,__FILE__, ERR)
#define MPI_FILE_WRITE_ORDERED_END( FH, BUF, STATUS_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_WRITE_ORDERED_END( FH, BUF, STATUS_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_GET_TYPE_EXTENT( FH, DATATYPE, EXTENT_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_GET_TYPE_EXTENT( FH, DATATYPE, EXTENT_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_SET_ATOMICITY( FH, FLAG, ERR) MPI_SOURCEINFO_FILE_SET_ATOMICITY( FH, FLAG,__LINE__,__FILE__, ERR)
#define MPI_FILE_GET_ATOMICITY( FH, FLAG, ERR) MPI_SOURCEINFO_FILE_GET_ATOMICITY( FH, FLAG,__LINE__,__FILE__, ERR)
#define MPI_FILE_SYNC( FH, ERR) MPI_SOURCEINFO_FILE_SYNC( FH,__LINE__,__FILE__, ERR)
#define MPI_REGISTER_DATAREP(datarep, read_conversion_fn, write_conversion_fn, dtype_file_extent_fn, extra_state,__LINE__,__FILE__, ERR) MPI_SOURCEINFO_REGISTER_DATAREP(datarep, read_conversion_fn, write_conversion_fn, dtype_file_extent_fn, extra_state,__LINE__,__FILE__, ERR)

#define MPI_CLOSE_PORT( PORT_NAME_CLASS_SINGLE_IN, ERR) MPI_SOURCEINFO_CLOSE_PORT( PORT_NAME_CLASS_SINGLE_IN,__LINE__,__FILE__, ERR)
#define MPI_COMM_ACCEPT( PORT_NAME_CLASS_SINGLE_IN, INFO, ROOT, COMM, NEWCOMM_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_COMM_ACCEPT( PORT_NAME_CLASS_SINGLE_IN, INFO, ROOT, COMM, NEWCOMM_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_COMM_CONNECT( PORT_NAME_CLASS_SINGLE_IN, INFO, ROOT, COMM, NEWCOMM_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_COMM_CONNECT( PORT_NAME_CLASS_SINGLE_IN, INFO, ROOT, COMM, NEWCOMM_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_COMM_DISCONNECT( COMM_CLASS_SINGLE_IO, ERR) MPI_SOURCEINFO_COMM_DISCONNECT( COMM_CLASS_SINGLE_IO,__LINE__,__FILE__, ERR)
#define MPI_COMM_GET_PARENT( PARENT_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_COMM_GET_PARENT( PARENT_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_COMM_JOIN( FD, INTERCOMM_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_COMM_JOIN( FD, INTERCOMM_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_COMM_SPAWN( COMMAND_CLASS_SINGLE_IN, ARGV, MAXPROCS, INFO, ROOT, COMM, INTERCOMM_CLASS_SINGLE_OUT, ARRAY_OF_ERRCODES, ERR) MPI_SOURCEINFO_COMM_SPAWN( COMMAND_CLASS_SINGLE_IN, ARGV, MAXPROCS, INFO, ROOT, COMM, INTERCOMM_CLASS_SINGLE_OUT, ARRAY_OF_ERRCODES,__LINE__,__FILE__, ERR)
#define MPI_COMM_SPAWN_MULTIPLE( COUNT, ARRAY_OF_COMMANDS, ARRAY_OF_ARGV, ARRAY_OF_MAXPROCS, ARRAY_OF_INFO_CLASS_ARRAY_IN_COUNT, ROOT, COMM, INTERCOMM_CLASS_SINGLE_OUT, ARRAY_OF_ERRCODES, ERR) MPI_SOURCEINFO_COMM_SPAWN_MULTIPLE( COUNT, ARRAY_OF_COMMANDS, ARRAY_OF_ARGV, ARRAY_OF_MAXPROCS, ARRAY_OF_INFO_CLASS_ARRAY_IN_COUNT, ROOT, COMM, INTERCOMM_CLASS_SINGLE_OUT, ARRAY_OF_ERRCODES,__LINE__,__FILE__, ERR)
#define MPI_LOOKUP_NAME( SERVICE_NAME_CLASS_SINGLE_IN, INFO, PORT_NAME_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_LOOKUP_NAME( SERVICE_NAME_CLASS_SINGLE_IN, INFO, PORT_NAME_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_OPEN_PORT( INFO, PORT_NAME_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_OPEN_PORT( INFO, PORT_NAME_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_PUBLISH_NAME( SERVICE_NAME_CLASS_SINGLE_IN, INFO, PORT_NAME_CLASS_SINGLE_IN, ERR) MPI_SOURCEINFO_PUBLISH_NAME( SERVICE_NAME_CLASS_SINGLE_IN, INFO, PORT_NAME_CLASS_SINGLE_IN,__LINE__,__FILE__, ERR)
#define MPI_UNPUBLISH_NAME( SERVICE_NAME_CLASS_SINGLE_IN, INFO, PORT_NAME_CLASS_SINGLE_IN, ERR) MPI_SOURCEINFO_UNPUBLISH_NAME( SERVICE_NAME_CLASS_SINGLE_IN, INFO, PORT_NAME_CLASS_SINGLE_IN,__LINE__,__FILE__, ERR)

#define MPI_ALLOC_MEM( SIZE, INFO, BASEPTR, ERR) MPI_SOURCEINFO_ALLOC_MEM( SIZE, INFO, BASEPTR,__LINE__,__FILE__, ERR)
#define MPI_COMM_CREATE_ERRHANDLER( FUNCTION, ERRHANDLER_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_COMM_CREATE_ERRHANDLER( FUNCTION, ERRHANDLER_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_COMM_GET_ERRHANDLER( COMM, ERRHANDLER_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_COMM_GET_ERRHANDLER( COMM, ERRHANDLER_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_COMM_SET_ERRHANDLER( COMM, ERRHANDLER, ERR) MPI_SOURCEINFO_COMM_SET_ERRHANDLER( COMM, ERRHANDLER,__LINE__,__FILE__, ERR)
#define MPI_FINALIZED( FLAG, ERR) MPI_SOURCEINFO_FINALIZED( FLAG,__LINE__,__FILE__, ERR)
#define MPI_FREE_MEM( BASE, ERR) MPI_SOURCEINFO_FREE_MEM( BASE,__LINE__,__FILE__, ERR)
#define MPI_GET_ADDRESS( LOCATION, ADDRESS_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_GET_ADDRESS( LOCATION, ADDRESS_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_INFO_CREATE( INFO_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_INFO_CREATE( INFO_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_INFO_DELETE( INFO, KEY_CLASS_SINGLE_IN, ERR) MPI_SOURCEINFO_INFO_DELETE( INFO, KEY_CLASS_SINGLE_IN,__LINE__,__FILE__, ERR)
#define MPI_INFO_DUP( INFO, NEWINFO_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_INFO_DUP( INFO, NEWINFO_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_INFO_FREE( INFO_CLASS_SINGLE_IO, ERR) MPI_SOURCEINFO_INFO_FREE( INFO_CLASS_SINGLE_IO,__LINE__,__FILE__, ERR)
#define MPI_INFO_GET( INFO, KEY_CLASS_SINGLE_IN, VALUELEN, VALUE_CLASS_SINGLE_OUT, FLAG, ERR) MPI_SOURCEINFO_INFO_GET( INFO, KEY_CLASS_SINGLE_IN, VALUELEN, VALUE_CLASS_SINGLE_OUT, FLAG,__LINE__,__FILE__, ERR)
#define MPI_INFO_GET_NKEYS( INFO, NKEYS, ERR) MPI_SOURCEINFO_INFO_GET_NKEYS( INFO, NKEYS,__LINE__,__FILE__, ERR)
#define MPI_INFO_GET_NTHKEY( INFO, N, KEY_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_INFO_GET_NTHKEY( INFO, N, KEY_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_INFO_GET_VALUELEN( INFO, KEY_CLASS_SINGLE_IN, VALUELEN, FLAG, ERR) MPI_SOURCEINFO_INFO_GET_VALUELEN( INFO, KEY_CLASS_SINGLE_IN, VALUELEN, FLAG,__LINE__,__FILE__, ERR)
#define MPI_INFO_SET( INFO, KEY_CLASS_SINGLE_IN, VALUE_CLASS_SINGLE_IN, ERR) MPI_SOURCEINFO_INFO_SET( INFO, KEY_CLASS_SINGLE_IN, VALUE_CLASS_SINGLE_IN,__LINE__,__FILE__, ERR)
#define MPI_PACK_EXTERNAL( DATAREP_CLASS_SINGLE_IN, INBUF, INCOUNT, DATATYPE, OUTBUF, OUTSIZE, POSITION_CLASS_SINGLE_IO, ERR) MPI_SOURCEINFO_PACK_EXTERNAL( DATAREP_CLASS_SINGLE_IN, INBUF, INCOUNT, DATATYPE, OUTBUF, OUTSIZE, POSITION_CLASS_SINGLE_IO,__LINE__,__FILE__, ERR)
#define MPI_PACK_EXTERNAL_SIZE( DATAREP_CLASS_SINGLE_IN, INCOUNT, DATATYPE, SIZE_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_PACK_EXTERNAL_SIZE( DATAREP_CLASS_SINGLE_IN, INCOUNT, DATATYPE, SIZE_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_REQUEST_GET_STATUS( REQUEST, FLAG, STATUS_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_REQUEST_GET_STATUS( REQUEST, FLAG, STATUS_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_TYPE_CREATE_DARRAY( SIZE, RANK, NDIMS, ARRAY_OF_GSIZES, ARRAY_OF_DISTRIBS, ARRAY_OF_DARGS, ARRAY_OF_PSIZES, ORDER, OLDTYPE, NEWTYPE_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_TYPE_CREATE_DARRAY( SIZE, RANK, NDIMS, ARRAY_OF_GSIZES, ARRAY_OF_DISTRIBS, ARRAY_OF_DARGS, ARRAY_OF_PSIZES, ORDER, OLDTYPE, NEWTYPE_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_TYPE_CREATE_HINDEXED( COUNT, ARRAY_OF_BLOCKLENGTHS, ARRAY_OF_DISPLACEMENTS_CLASS_ARRAY_IN_COUNT, OLDTYPE, NEWTYPE_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_TYPE_CREATE_HINDEXED( COUNT, ARRAY_OF_BLOCKLENGTHS, ARRAY_OF_DISPLACEMENTS_CLASS_ARRAY_IN_COUNT, OLDTYPE, NEWTYPE_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_TYPE_CREATE_HVECTOR( COUNT, BLOCKLENGTH, STRIDE, OLDTYPE, NEWTYPE_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_TYPE_CREATE_HVECTOR( COUNT, BLOCKLENGTH, STRIDE, OLDTYPE, NEWTYPE_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_TYPE_CREATE_INDEXED_BLOCK( COUNT, BLOCKLENGTH, ARRAY_OF_DISPLACEMENTS, OLDTYPE, NEWTYPE_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_TYPE_CREATE_INDEXED_BLOCK( COUNT, BLOCKLENGTH, ARRAY_OF_DISPLACEMENTS, OLDTYPE, NEWTYPE_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_TYPE_CREATE_RESIZED( OLDTYPE, LB, EXTENT, NEWTYPE_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_TYPE_CREATE_RESIZED( OLDTYPE, LB, EXTENT, NEWTYPE_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_TYPE_CREATE_STRUCT( COUNT, ARRAY_OF_BLOCKLENGTHS, ARRAY_OF_DISPLACEMENTS_CLASS_ARRAY_IN_COUNT, ARRAY_OF_TYPES_CLASS_ARRAY_IN_COUNT, NEWTYPE_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_TYPE_CREATE_STRUCT( COUNT, ARRAY_OF_BLOCKLENGTHS, ARRAY_OF_DISPLACEMENTS_CLASS_ARRAY_IN_COUNT, ARRAY_OF_TYPES_CLASS_ARRAY_IN_COUNT, NEWTYPE_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_TYPE_CREATE_SUBARRAY( NDIMS, ARRAY_OF_SIZES, ARRAY_OF_SUBSIZES, ARRAY_OF_STARTS, ORDER, OLDTYPE, NEWTYPE_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_TYPE_CREATE_SUBARRAY( NDIMS, ARRAY_OF_SIZES, ARRAY_OF_SUBSIZES, ARRAY_OF_STARTS, ORDER, OLDTYPE, NEWTYPE_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_TYPE_GET_EXTENT( DATATYPE, LB_CLASS_SINGLE_OUT, EXTENT_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_TYPE_GET_EXTENT( DATATYPE, LB_CLASS_SINGLE_OUT, EXTENT_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_TYPE_GET_TRUE_EXTENT( DATATYPE, TRUE_LB_CLASS_SINGLE_OUT, TRUE_EXTENT_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_TYPE_GET_TRUE_EXTENT( DATATYPE, TRUE_LB_CLASS_SINGLE_OUT, TRUE_EXTENT_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_UNPACK_EXTERNAL( DATAREP_CLASS_SINGLE_IN, INBUF, INSIZE, POSITION_CLASS_SINGLE_IO, OUTBUF, OUTCOUNT, DATATYPE, ERR) MPI_SOURCEINFO_UNPACK_EXTERNAL( DATAREP_CLASS_SINGLE_IN, INBUF, INSIZE, POSITION_CLASS_SINGLE_IO, OUTBUF, OUTCOUNT, DATATYPE,__LINE__,__FILE__, ERR)
#define MPI_WIN_CREATE_ERRHANDLER( FUNCTION, ERRHANDLER_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_WIN_CREATE_ERRHANDLER( FUNCTION, ERRHANDLER_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_WIN_GET_ERRHANDLER( WIN, ERRHANDLER_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_WIN_GET_ERRHANDLER( WIN, ERRHANDLER_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_WIN_SET_ERRHANDLER( WIN, ERRHANDLER, ERR) MPI_SOURCEINFO_WIN_SET_ERRHANDLER( WIN, ERRHANDLER,__LINE__,__FILE__, ERR)
#define MPI_FILE_CALL_ERRHANDLER( FH, ERRORCODE, ERR) MPI_SOURCEINFO_FILE_CALL_ERRHANDLER( FH, ERRORCODE,__LINE__,__FILE__, ERR)
#define MPI_FILE_CREATE_ERRHANDLER( FUNCTION_CLASS_SINGLE_IN, ERRHANDLER_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_CREATE_ERRHANDLER( FUNCTION_CLASS_SINGLE_IN, ERRHANDLER_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_GET_ERRHANDLER( FILE, ERRHANDLER_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_FILE_GET_ERRHANDLER( FILE, ERRHANDLER_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_FILE_SET_ERRHANDLER( FILE, ERRHANDLER, ERR) MPI_SOURCEINFO_FILE_SET_ERRHANDLER( FILE, ERRHANDLER,__LINE__,__FILE__, ERR)

/* EXTERNAL INTERFACES */
#define MPI_ADD_ERROR_CLASS( ERRORCLASS, ERR) MPI_SOURCEINFO_ADD_ERROR_CLASS( ERRORCLASS,__LINE__,__FILE__, ERR)
#define MPI_ADD_ERROR_CODE( ERRORCLASS, ERRORCODE, ERR) MPI_SOURCEINFO_ADD_ERROR_CODE( ERRORCLASS, ERRORCODE,__LINE__,__FILE__, ERR)
#define MPI_ADD_ERROR_STRING( ERRORCODE, STRING_CLASS_SINGLE_IN, ERR) MPI_SOURCEINFO_ADD_ERROR_STRING( ERRORCODE, STRING_CLASS_SINGLE_IN,__LINE__,__FILE__, ERR)
#define MPI_COMM_CALL_ERRHANDLER( COMM, ERRORCODE, ERR) MPI_SOURCEINFO_COMM_CALL_ERRHANDLER( COMM, ERRORCODE,__LINE__,__FILE__, ERR)
#define MPI_COMM_CREATE_KEYVAL( COMM_COPY_ATTR_FN, COMM_DELETE_ATTR_FN, COMM_KEYVAL, EXTRA_STATE, ERR) MPI_SOURCEINFO_COMM_CREATE_KEYVAL( COMM_COPY_ATTR_FN, COMM_DELETE_ATTR_FN, COMM_KEYVAL, EXTRA_STATE,__LINE__,__FILE__, ERR)
#define MPI_COMM_DELETE_ATTR( COMM, COMM_KEYVAL, ERR) MPI_SOURCEINFO_COMM_DELETE_ATTR( COMM, COMM_KEYVAL,__LINE__,__FILE__, ERR)
#define MPI_COMM_FREE_KEYVAL( COMM_KEYVAL, ERR) MPI_SOURCEINFO_COMM_FREE_KEYVAL( COMM_KEYVAL,__LINE__,__FILE__, ERR)
#define MPI_COMM_GET_ATTR( COMM, COMM_KEYVAL, ATTRIBUTE_VAL, FLAG, ERR) MPI_SOURCEINFO_COMM_GET_ATTR( COMM, COMM_KEYVAL, ATTRIBUTE_VAL, FLAG,__LINE__,__FILE__, ERR)
#define MPI_COMM_GET_NAME( COMM, COMM_NAME_CLASS_SINGLE_OUT, RESULTLEN, ERR) MPI_SOURCEINFO_COMM_GET_NAME( COMM, COMM_NAME_CLASS_SINGLE_OUT, RESULTLEN,__LINE__,__FILE__, ERR)
#define MPI_COMM_SET_ATTR( COMM, COMM_KEYVAL, ATTRIBUTE_VAL, ERR) MPI_SOURCEINFO_COMM_SET_ATTR( COMM, COMM_KEYVAL, ATTRIBUTE_VAL,__LINE__,__FILE__, ERR)
#define MPI_COMM_SET_NAME( COMM, COMM_NAME_CLASS_SINGLE_IN, ERR) MPI_SOURCEINFO_COMM_SET_NAME( COMM, COMM_NAME_CLASS_SINGLE_IN,__LINE__,__FILE__, ERR)
#define MPI_GREQUEST_COMPLETE( REQUEST, ERR) MPI_SOURCEINFO_GREQUEST_COMPLETE( REQUEST,__LINE__,__FILE__, ERR)
#define MPI_GREQUEST_START( QUERY_FN, FREE_FN, CANCEL_FN, EXTRA_STATE, REQUEST_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_GREQUEST_START( QUERY_FN, FREE_FN, CANCEL_FN, EXTRA_STATE, REQUEST_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
/*#define MPI_INIT_THREAD( ARGC, ARGV, REQUIRED, PROVIDED, ERR) MPI_SOURCEINFO_INIT_THREAD( ARGC, ARGV, REQUIRED, PROVIDED, ERR)*/ /*STAYS IN MPI_STANDARD.H FOR HISTORIC REASONS!*/
#define MPI_IS_THREAD_MAIN( FLAG, ERR) MPI_SOURCEINFO_IS_THREAD_MAIN( FLAG,__LINE__,__FILE__, ERR)
#define MPI_QUERY_THREAD( PROVIDED, ERR) MPI_SOURCEINFO_QUERY_THREAD( PROVIDED,__LINE__,__FILE__, ERR)
#define MPI_STATUS_SET_CANCELLED( STATUS_CLASS_SINGLE_IO, FLAG, ERR) MPI_SOURCEINFO_STATUS_SET_CANCELLED( STATUS_CLASS_SINGLE_IO, FLAG,__LINE__,__FILE__, ERR)
#define MPI_STATUS_SET_ELEMENTS( STATUS_CLASS_SINGLE_IO, DATATYPE, COUNT, ERR) MPI_SOURCEINFO_STATUS_SET_ELEMENTS( STATUS_CLASS_SINGLE_IO, DATATYPE, COUNT,__LINE__,__FILE__, ERR)
#define MPI_TYPE_CREATE_KEYVAL( TYPE_COPY_ATTR_FN, TYPE_DELETE_ATTR_FN, TYPE_KEYVAL, EXTRA_STATE, ERR) MPI_SOURCEINFO_TYPE_CREATE_KEYVAL( TYPE_COPY_ATTR_FN, TYPE_DELETE_ATTR_FN, TYPE_KEYVAL, EXTRA_STATE,__LINE__,__FILE__, ERR)
#define MPI_TYPE_DELETE_ATTR( TYPE, TYPE_KEYVAL, ERR) MPI_SOURCEINFO_TYPE_DELETE_ATTR( TYPE, TYPE_KEYVAL,__LINE__,__FILE__, ERR)
#define MPI_TYPE_DUP( TYPE, NEWTYPE_CLASS_SINGLE_OUT, ERR) MPI_SOURCEINFO_TYPE_DUP( TYPE, NEWTYPE_CLASS_SINGLE_OUT,__LINE__,__FILE__, ERR)
#define MPI_TYPE_FREE_KEYVAL( TYPE_KEYVAL, ERR) MPI_SOURCEINFO_TYPE_FREE_KEYVAL( TYPE_KEYVAL,__LINE__,__FILE__, ERR)
#define MPI_TYPE_GET_ATTR( TYPE, TYPE_KEYVAL, ATTRIBUTE_VAL, FLAG, ERR) MPI_SOURCEINFO_TYPE_GET_ATTR( TYPE, TYPE_KEYVAL, ATTRIBUTE_VAL, FLAG,__LINE__,__FILE__, ERR)
#define MPI_TYPE_GET_CONTENTS( DATATYPE, MAX_INTEGERS, MAX_ADDRESSES, MAX_DATATYPES, ARRAY_OF_INTEGERS, ARRAY_OF_ADDRESSES_CLASS_ARRAY_OUT_MAX_ADDRESSES, ARRAY_OF_DATATYPES_CLASS_ARRAY_OUT_MAX_DATATYPES, ERR) MPI_SOURCEINFO_TYPE_GET_CONTENTS( DATATYPE, MAX_INTEGERS, MAX_ADDRESSES, MAX_DATATYPES, ARRAY_OF_INTEGERS, ARRAY_OF_ADDRESSES_CLASS_ARRAY_OUT_MAX_ADDRESSES, ARRAY_OF_DATATYPES_CLASS_ARRAY_OUT_MAX_DATATYPES,__LINE__,__FILE__, ERR)
#define MPI_TYPE_GET_ENVELOPE( DATATYPE, NUM_INTEGERS, NUM_ADDRESSES, NUM_DATATYPES, COMBINER, ERR) MPI_SOURCEINFO_TYPE_GET_ENVELOPE( DATATYPE, NUM_INTEGERS, NUM_ADDRESSES, NUM_DATATYPES, COMBINER,__LINE__,__FILE__, ERR)
#define MPI_TYPE_GET_NAME( TYPE, TYPE_NAME_CLASS_SINGLE_OUT, RESULTLEN, ERR) MPI_SOURCEINFO_TYPE_GET_NAME( TYPE, TYPE_NAME_CLASS_SINGLE_OUT, RESULTLEN,__LINE__,__FILE__, ERR)
#define MPI_TYPE_SET_ATTR( TYPE, TYPE_KEYVAL, ATTRIBUTE_VAL, ERR) MPI_SOURCEINFO_TYPE_SET_ATTR( TYPE, TYPE_KEYVAL, ATTRIBUTE_VAL,__LINE__,__FILE__, ERR)
#define MPI_TYPE_SET_NAME( TYPE, TYPE_NAME_CLASS_SINGLE_IN, ERR) MPI_SOURCEINFO_TYPE_SET_NAME( TYPE, TYPE_NAME_CLASS_SINGLE_IN,__LINE__,__FILE__, ERR)
#define MPI_WIN_CALL_ERRHANDLER( WIN, ERRORCODE, ERR) MPI_SOURCEINFO_WIN_CALL_ERRHANDLER( WIN, ERRORCODE,__LINE__,__FILE__, ERR)
#define MPI_WIN_CREATE_KEYVAL( WIN_COPY_ATTR_FN, WIN_DELETE_ATTR_FN, WIN_KEYVAL, EXTRA_STATE, ERR) MPI_SOURCEINFO_WIN_CREATE_KEYVAL( WIN_COPY_ATTR_FN, WIN_DELETE_ATTR_FN, WIN_KEYVAL, EXTRA_STATE,__LINE__,__FILE__, ERR)
#define MPI_WIN_DELETE_ATTR( WIN, WIN_KEYVAL, ERR) MPI_SOURCEINFO_WIN_DELETE_ATTR( WIN, WIN_KEYVAL,__LINE__,__FILE__, ERR)
#define MPI_WIN_FREE_KEYVAL( WIN_KEYVAL, ERR) MPI_SOURCEINFO_WIN_FREE_KEYVAL( WIN_KEYVAL,__LINE__,__FILE__, ERR)
#define MPI_WIN_GET_ATTR( WIN, WIN_KEYVAL, ATTRIBUTE_VAL, FLAG, ERR) MPI_SOURCEINFO_WIN_GET_ATTR( WIN, WIN_KEYVAL, ATTRIBUTE_VAL, FLAG,__LINE__,__FILE__, ERR)
#define MPI_WIN_GET_NAME( WIN, WIN_NAME_CLASS_SINGLE_OUT, RESULTLEN, ERR) MPI_SOURCEINFO_WIN_GET_NAME( WIN, WIN_NAME_CLASS_SINGLE_OUT, RESULTLEN,__LINE__,__FILE__, ERR)
#define MPI_WIN_SET_ATTR( WIN, WIN_KEYVAL, ATTRIBUTE_VAL, ERR) MPI_SOURCEINFO_WIN_SET_ATTR( WIN, WIN_KEYVAL, ATTRIBUTE_VAL,__LINE__,__FILE__, ERR)
#define MPI_WIN_SET_NAME( WIN, WIN_NAME_CLASS_SINGLE_IN, ERR) MPI_SOURCEINFO_WIN_SET_NAME( WIN, WIN_NAME_CLASS_SINGLE_IN,__LINE__,__FILE__, ERR)
#define MPI_Type_create_f90_complex( p,  r, newtype_CLASS_SINGLE_OUT) MPI_SOURCEINFO_Type_create_f90_complex(p, r,  newtype_CLASS_SINGLE_OUT,__LINE__,__FILE__)
#define MPI_Type_create_f90_integer( r,  newtype_CLASS_SINGLE_OUT) MPI_SOURCEINFO_Type_create_f90_integer( r,  newtype_CLASS_SINGLE_OUT,__LINE__,__FILE__)
#define MPI_Type_create_f90_real(p, r,  newtype_CLASS_SINGLE_OUT) MPI_SOURCEINFO_Type_create_f90_real( p,  r,  newtype_CLASS_SINGLE_OUT,__LINE__,__FILE__)
#define MPI_Type_match_size( typeclass,  size,  type_CLASS_SINGLE_OUT) MPI_SOURCEINFO_Type_match_size( typeclass,  size,  type_CLASS_SINGLE_OUT,__LINE__,__FILE__)
#define MPI_TYPE_CREATE_F90_COMPLEX( P,  R, NEWTYPE_CLASS_SINGLE_OUT) MPI_SOURCEINFO_TYPE_CREATE_F90_COMPLEX(P, R,  NEWTYPE_CLASS_SINGLE_OUT,__LINE__,__FILE__)
#define MPI_TYPE_CREATE_F90_INTEGER( R,  NEWTYPE_CLASS_SINGLE_OUT) MPI_SOURCEINFO_TYPE_CREATE_F90_INTEGER( R,  NEWTYPE_CLASS_SINGLE_OUT,__LINE__,__FILE__)
#define MPI_TYPE_CREATE_F90_REAL(P, R,  NEWTYPE_CLASS_SINGLE_OUT) MPI_SOURCEINFO_TYPE_CREATE_F90_REAL( P,  R,  NEWTYPE_CLASS_SINGLE_OUT,__LINE__,__FILE__)
#define MPI_TYPE_MATCH_SIZE( TYPECLASS,  SIZE,  TYPE_CLASS_SINGLE_OUT) MPI_SOURCEINFO_TYPE_MATCH_SIZE( TYPECLASS,  SIZE,  TYPE_CLASS_SINGLE_OUT,__LINE__,__FILE__)
