/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
/**
  * @file
  * This Headerfile declares the functions used to retrieve the handles for
  * the optional FORTRAN datatypes.
  * @author Tobias Hilbrich
  * @date 04.10.2006
  * $Id$
  */

#ifndef MPOFORTRANDATATYPEHELPERS_H_
#define MPOFORTRANDATATYPEHELPERS_H_

#include "config.h"

#ifndef MARMOT_NO_FORTRAN
#include "mpo-fortran-datatypehelper-mangling.h"

extern "C" void GET_MPI_INTEGER_CODE (MPI_Fint*);
extern "C" void GET_MPI_REAL_CODE (MPI_Fint*);
extern "C" void GET_MPI_DOUBLE_PRECISION_CODE (MPI_Fint*);
extern "C" void GET_MPI_COMPLEX_CODE (MPI_Fint*);
extern "C" void GET_MPI_LOGICAL_CODE (MPI_Fint*);
extern "C" void GET_MPI_CHARACTER_CODE (MPI_Fint*);

extern "C" void GET_MPI_INTEGER1_CODE (MPI_Fint*);
extern "C" void GET_MPI_INTEGER2_CODE (MPI_Fint*);
extern "C" void GET_MPI_INTEGER4_CODE (MPI_Fint*);
extern "C" void GET_MPI_INTEGER8_CODE (MPI_Fint*);
extern "C" void GET_MPI_INTEGER16_CODE (MPI_Fint*);
extern "C" void GET_MPI_REAL2_CODE (MPI_Fint*);
extern "C" void GET_MPI_REAL4_CODE (MPI_Fint*);
extern "C" void GET_MPI_REAL8_CODE (MPI_Fint*);
extern "C" void GET_MPI_REAL16_CODE (MPI_Fint*);
extern "C" void GET_MPI_DOUBLE_COMPLEX_CODE (MPI_Fint*);
extern "C" void GET_MPI_COMPLEX8_CODE (MPI_Fint*);
extern "C" void GET_MPI_COMPLEX16_CODE (MPI_Fint*);
extern "C" void GET_MPI_COMPLEX32_CODE (MPI_Fint*);
extern "C" void GET_MPI_LOGICAL1_CODE (MPI_Fint*);
extern "C" void GET_MPI_LOGICAL2_CODE (MPI_Fint*);
extern "C" void GET_MPI_LOGICAL4_CODE (MPI_Fint*);
extern "C" void GET_MPI_LOGICAL8_CODE (MPI_Fint*);
extern "C" void GET_MPI_LOGICAL16_CODE (MPI_Fint*);

extern "C" void GET_MPI_2INTEGER_CODE (MPI_Fint*);
extern "C" void GET_MPI_2REAL_CODE (MPI_Fint*);
extern "C" void GET_MPI_2DOUBLE_PRECISION_CODE (MPI_Fint*);
extern "C" void GET_MPI_2COMPLEX_CODE (MPI_Fint*);
extern "C" void GET_MPI_2DOUBLE_COMPLEX_CODE (MPI_Fint*);

extern "C" void GET_MPI_STATUS_SIZE (int*);

#endif /*MARMOT_NO_FORTRAN*/

#endif /*MPOFORTRANDATATYPEHELPERS_H_*/
