/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
/**
 *  @file
 *
 *  Definition of class MPO_Get_address.
 *
 *  @author Tobias Hilbrich
 *
 *  $Id$
 */


#include "mpo-objects.h"
#include "mpo-2-objects.h"
#include "mpo-binaryIO.h"
#include "mpo-debugserver.h"
#include "mpo_MsgObject.h"
#include "MPO_LogFile.h"
#include "MPO_ResourceGatherer.h"
#include <stdio.h>

#ifdef IS_MPI_GET_ADDRESS_PRESENT

namespace MPO
{
    // default constructor
    //========================================================================
	MPO_Get_address::MPO_Get_address()
        : MPO_Address()
    {
		//Nothing to do
    }

    // proper constructor
    //========================================================================
	MPO_Get_address::MPO_Get_address (
			void *location, MPI_Aint * address
        	)
		: MPO_Address (location, address)
	{
		//Nothing to do
	}

	// getCallname
	//========================================================================
	string MPO_Get_address::getCallname() const
	{
		/*  Distinguish between C and Fortran interface, default: C interface.
		 */
		string rvalue = "MPI_Get_address";

		if (F_INTERFACE == INTERFACE_MODE)
		{
			rvalue = "MPI_GET_ADDRESS";
		}

		return rvalue;
	}

	// getId
	//========================================================================
	int MPO_Get_address::getId() const
	{
		// returns the unique call identity set by enum MPO_CALL_ID
		return MPO_GET_ADDRESS_ID;
	}
}

#endif /*IS_MPI_GET_ADDRESS_PRESENT*/
