/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
/**
 *  @file
 *
 *  Definition of class MPO_Type_create_hvector.
 *
 *  @author Tobias Hilbrich
 *
 *  $Id$
 */



#include "mpo-objects.h"
#include "mpo-2-objects.h"
#include "mpo-binaryIO.h"
#include "mpo-debugserver.h"
#include "mpo_MsgObject.h"
#include "MPO_LogFile.h"
#include "MPO_ResourceGatherer.h"
#include <stdio.h>

#ifdef IS_MPI_TYPE_CREATE_HVECTOR_PRESENT

namespace MPO
{
    // default constructor
    //========================================================================
	MPO_Type_create_hvector::MPO_Type_create_hvector()
        : MPO_Type_hvector()
    {
		//Nothing to do
    }

    // proper constructor
    //========================================================================
	MPO_Type_create_hvector::MPO_Type_create_hvector (
			int count,
			int blocklength,
			MPI_Aint stride,
			MPO_Datatype oldtype,
			MPI_Datatype * newtype
			)
		: MPO_Type_hvector (count, blocklength, stride, oldtype, newtype)
	{
		//Nothing to do
	}

	// getCallname
	//========================================================================
	string MPO_Type_create_hvector::getCallname() const
	{
		/*  Distinguish between C and Fortran interface, default: C interface.
		 */
		string rvalue = "MPI_Type_create_hvector";

		if (F_INTERFACE == INTERFACE_MODE)
		{
			rvalue = "MPI_TYPE_CREATE_HVECTOR";
		}

		return rvalue;
	}

	// getId
	//========================================================================
	int MPO_Type_create_hvector::getId() const
	{
		// returns the unique call identity set by enum MPO_CALL_ID
		return MPO_TYPE_CREATE_HVECTOR_ID;
	}
}

#endif /*IS_MPI_TYPE_CREATE_HVECTOR_PRESENT*/

/*EOF*/
