/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
/**
 *  @file
 *
 *  Definition of class MPO_Type_create_struct.
 *
 *  @author Tobias Hilbrich
 *
 *  $Id$
 */


#include "mpo-objects.h"
#include "mpo-2-objects.h"
#include "mpo-binaryIO.h"
#include "mpo-debugserver.h"
#include "mpo_MsgObject.h"
#include "MPO_LogFile.h"
#include "MPO_ResourceGatherer.h"
#include <stdio.h>

#ifdef IS_MPI_TYPE_CREATE_STRUCT_PRESENT

namespace MPO
{
    // default constructor
    //========================================================================
    MPO_Type_create_struct::MPO_Type_create_struct()
        : MPO_Type_struct()
    {
    	//nothing to do
    }

    // proper constructor
    //========================================================================
    MPO_Type_create_struct::MPO_Type_create_struct (
    		int count,
    		int *blocklength,
    		MPI_Aint * displ_array,
    		MPI_Datatype * oldtype,
    		MPI_Datatype * newtype
    )
    : MPO_Type_struct (count, blocklength, displ_array, oldtype, newtype)
    {
		//nothing to do
    }

	// getCallname
	//========================================================================
	string MPO_Type_create_struct::getCallname() const
	{
		/*  Distinguish between C and Fortran interface, default: C interface.
		 */
		string rvalue = "MPI_Type_create_struct";

		if (F_INTERFACE == INTERFACE_MODE)
    	{
    		rvalue = "MPI_TYPE_CREATE_STRUCT";
    	}

		return rvalue;
    }

	// getId
	//========================================================================
	int MPO_Type_create_struct::getId() const
    {
        // returns the unique call identity set by enum MPO_CALL_ID
        return MPO_TYPE_CREATE_STRUCT_ID;
    }
}

#endif /*IS_MPI_TYPE_CREATE_STRUCT_PRESENT*/
