/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
/**
 *  @file
 *
 *  Definition of the abstract base class MPO_Environment.
 * 
 *  @author Bettina Krammer
 *
 *  $Id: MPO_Environment.cc 838 2008-06-13 10:44:34Z hpchimml $
 */


#include "mpo.h"
#include "mpo-objects.h"
#include "mpo-binaryIO.h"
#include "mpo-debugserver.h"
#include "mpo-messenger.h"
#include "mpo-autogenerated.h"

namespace MPO
{

    // default constructor
    //========================================================================
    MPO_Environment::MPO_Environment()
    {
    }


    // destructor
    //========================================================================
    MPO_Environment::~MPO_Environment()
    {
    }


    /* There are some pure virtual methods, see mpo.h.
     */


    // getFamilyId
    //========================================================================
    int MPO_Environment::getFamilyId() const
    {
        // returns the unique family identity set by enum MPO_FAMILY_ID
        return MPO_CALLOBJECT_ID;
    }


}                               // end of namespace MPO
