/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
/**
 *  @file
 *
 *  Definition of the abstract base class MPO_Object.
 *
 *  This abstract base class represents calls, types and messages.
 * 
 *  @author Bettina Krammer
 *
 *  $Id: MPO_Object.cc 838 2008-06-13 10:44:34Z hpchimml $
 */


#include "mpo.h"
#include "mpo-objects.h"
#include "mpo-binaryIO.h"
#include "mpo-debugserver.h"

namespace MPO
{

    // default constructor
    //========================================================================
    MPO_Object::MPO_Object()
    {
    }


    // destructor
    //========================================================================
    MPO_Object::~MPO_Object()
    {
    }


    /** There are some pure virtual methods, see mpo.h.
     */


    // <<
    //========================================================================
    std::ostream & operator <<(std::ostream & output,
                              const MPO::MPO_Object & rhs)
    {
        return rhs.debugout(output);
    }


}                               // end of namespace MPO
