#include "StdAfx.h"
#include "DICE_DataItem.h"
#include <fstream>

namespace DICE_BACK
{

	CDICE_DataItem::CDICE_DataItem(void)
	{
		m_desc = "";
		m_DICE_id = 0;
		m_father = NULL;
	}

	CDICE_DataItem::CDICE_DataItem(std::string desc, long DICE_id)
	{
		m_desc = desc;
		m_DICE_id = DICE_id;
		m_father = NULL;
	}

	CDICE_DataItem::~CDICE_DataItem(void)
	{
		m_father = NULL;
	}

	std::string CDICE_DataItem::getDesc (void)
	{
		return m_desc;
	}

	void CDICE_DataItem::setDesc (std::string desc)
	{
		m_desc = desc;
	}

	long CDICE_DataItem::getDICEid (void)
	{
		return m_DICE_id;
	}

	void CDICE_DataItem::setDICEid (long id)
	{
		m_DICE_id = id;
	}

	CDICE_DataItem* CDICE_DataItem::getFather (void)
	{
		return m_father;
	}

	void CDICE_DataItem::setFather(CDICE_DataItem* father)
	{
		m_father = father;
	}

	CDICE_DataItem* CDICE_DataItem::findDICEid (long id)
	{
		if (m_DICE_id == id)
			return this;

		return NULL;
	}

	long CDICE_DataItem::findDesc (std::string desc)
	{
		if (m_desc.compare(desc) == 0)
			return m_DICE_id;

		return -1;
	}

	std::list<long> CDICE_DataItem::accumulateIDs (void)
	{
		std::list<long> ret;
		ret.clear();
		ret.push_back(m_DICE_id);
		return ret;
	}

	bool CDICE_DataItem::save (std::ofstream &file)
	{
		file << m_DICE_id << std::endl;
		
		size_t pos;
		std::string string = m_desc;
		do 
		{
			pos = string.find ("\r\n");
			if (pos != std::string::npos)
			{
				string.replace (pos,2,"<RN-DICE-BREAK-LINE>");
			}
			else
			{
				pos = string.find ("\n");
				if (pos != std::string::npos)
					string.replace (pos,1,"<N-DICE-BREAK-LINE>");
			}
		} while (pos != std::string::npos);
		file << string << std::endl;

		return true;
	}

	bool CDICE_DataItem::load (std::ifstream &file)
	{
		file >> m_DICE_id;
		
		std::string string;
		size_t pos;

		std::getline (file, string);
		std::getline (file, string);
	
		do 
		{
			pos = string.find ("<RN-DICE-BREAK-LINE>");
			if (pos != std::string::npos)
			{
				string.replace (pos,strlen("<RN-DICE-BREAK-LINE>"),"\r\n");
			}
			else
			{
				pos = string.find ("<N-DICE-BREAK-LINE>");
				if (pos != std::string::npos)
					string.replace (pos,strlen("<N-DICE-BREAK-LINE>"),"\n");
			}
		} while (pos != std::string::npos);
		m_desc = string;

		return true;
	}

} //end of namespace DICE_BACK