/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#pragma once

#include <string>
#include <list>
#include "DICE_Interface.h"

namespace DICE_BACK
{

	struct SDICE_LinkType
	{
		long locationsID;
		long systemID;
		double severity;
	};

	class CDICE_DataItem
	{
	protected:
		std::string m_desc;
		long m_DICE_id;
		CDICE_DataItem* m_father;

	public:
		CDICE_DataItem(void);
		CDICE_DataItem(std::string desc, long DICE_id);
		~CDICE_DataItem(void);

		std::string getDesc (void);
		void setDesc (std::string);

		long getDICEid (void);
		void setDICEid (long);

		CDICE_DataItem* getFather (void);
		void setFather(CDICE_DataItem*);

		virtual double calculateSeverity (void) = 0;
		virtual std::list<SDICE_LinkType> accumulateLinks (void) = 0;
		virtual CDICE_DataItem* findDICEid (long);
		virtual long findDesc (std::string desc);
		virtual bool isLeaf (void) = 0;
		virtual std::list<long> accumulateIDs (void);
		virtual DICE_INTERFACE::CDICE_TreeItem* copyToInterfaceTree (void) = 0;
		virtual DICE_INTERFACE::CDICE_TreeItem* copyToInterfaceTreeWeighted (std::list<std::pair<long,double> > weights) = 0;
		virtual bool deleteTree (void) = 0;
		virtual bool save (std::ofstream &file);
		virtual bool load (std::ifstream &file);
	};

}//end of namespace DICE_BACK