/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#pragma once

#include "DICE_interface.h"

namespace DICE_BACK
{

	class CDICE_Report : public DICE_INTERFACE::CDICE_Message
	{
	protected:
		long m_IDmessages;
		long m_IDlocations;
		long m_IDsystem;

	public:
		CDICE_Report(void);
		CDICE_Report(
			long timestamp,
			int sourceRank,
			int sourceThread,
			std::string callName,
			std::string shortDesc,
			std::string text,
			std::string locationFileName,
			long locationLine,
			DICE_INTERFACE::EMESSAGE_TYPE type,
			std::string mpiReference,
			long IDmessages,
			long IDlocations,
			long IDsystem);
		CDICE_Report(
			DICE_INTERFACE::CDICE_Message msg,
			long IDmessages,
			long IDlocations,
			long IDsystem);
		~CDICE_Report(void);

		long getIDmessages (void);
		void setIDmessages (long);

		long getIDlocations (void);
		void setIDlocations (long);

		long getIDsystem (void);
		void setIDsystem (long);
		DICE_INTERFACE::CDICE_Message getMessage (void);

		bool save (std::ofstream &file);
		bool load (std::ifstream &file);
		void save_string (std::ofstream &file, std::string string);
		std::string load_string (std::ifstream &file);
	};

} //end of namespace DICE_BACK