#include "StdAfx.h"
#include "DICE_ReportCollection.h"
#include <fstream>

namespace DICE_BACK
{

	CDICE_ReportCollection* CDICE_ReportCollection::m_theInstance = NULL;

	CDICE_ReportCollection::CDICE_ReportCollection(void)
	{
		m_reports.clear();
	}

	CDICE_ReportCollection::~CDICE_ReportCollection(void)
	{
		m_reports.clear();
	}

	CDICE_ReportCollection* CDICE_ReportCollection::GetInstance(void)
	{
		if (m_theInstance == NULL)
		{
			m_theInstance = new CDICE_ReportCollection();
		}
		return m_theInstance;
	}

	bool CDICE_ReportCollection::addReport (DICE_INTERFACE::CDICE_Message msg, long IDmessages, long IDlocations, long IDsystem)
	{
		CDICE_Report report (msg, IDmessages, IDlocations, IDsystem);
		m_reports.push_back(report);
		return true;
	}

	std::list<DICE_INTERFACE::CDICE_Message> CDICE_ReportCollection::getMatchingReports(std::list<long> messagesIDs, std::list<long> locationsIDs, std::list<long> systemIDs)
	{
		/**
		 * TODO: Extremly slow implementation !!!
		 */
		std::list<DICE_INTERFACE::CDICE_Message> ret;
		ret.clear();
		std::list<long>::iterator i,j,k;

		for (i = messagesIDs.begin();i != messagesIDs.end();i++)
		{
			for (j = locationsIDs.begin();j != locationsIDs.end(); j++)
			{
				for (k = systemIDs.begin();k != systemIDs.end();k++)
				{
					std::list<DICE_INTERFACE::CDICE_Message> temp;
					
					temp = getMatchingReports(*i, *j, *k);
					
					std::list<DICE_INTERFACE::CDICE_Message>::iterator l;
					for (l = temp.begin(); l != temp.end();l++)
					{
						ret.push_back(*l);
					}
				}
			}
		}
		
		return ret;
	}

	std::list<DICE_INTERFACE::CDICE_Message> CDICE_ReportCollection::getMatchingReports(long messagesID, long locationsID, long systemID)
	{
		std::list<DICE_INTERFACE::CDICE_Message> ret;
		std::list<CDICE_Report>::iterator i;
		
		ret.clear();

		for (i = m_reports.begin(); i != m_reports.end(); i++)
		{
			if (i->getIDmessages() != messagesID)
				continue;

			if (i->getIDlocations() != locationsID)
				continue;

			if (i->getIDsystem() != systemID)
				continue;

			ret.push_back(i->getMessage());
		}

		return ret;
	}

	bool CDICE_ReportCollection::deleteReports (void)
	{
		m_reports.clear();
		return true;
	}

	bool CDICE_ReportCollection::save (std::ofstream &file)
	{
		bool ret = true;

		//data
		file << m_reports.size() << std::endl;

		std::list<CDICE_Report>::iterator i;
		for (i = m_reports.begin();i != m_reports.end();i++)
		{
			ret = ret && i->save (file);
		}			

		return ret;
	}

    bool CDICE_ReportCollection::load (std::ifstream &file)
	{
		bool ret = true;

		//data
		int num_reports, i;
		file >> num_reports;

		for (i = 0; i < num_reports;i++)
		{
			CDICE_Report report;
			ret = ret && report.load (file);
			m_reports.push_back(report);
		}

		return ret;
	}

}//end of namespace DICE_BACK