/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#pragma once

#include "DICE_Report.h"
#include <list>

namespace DICE_BACK
{

	class CDICE_ReportCollection
	{
	private:
		CDICE_ReportCollection(void);
		static CDICE_ReportCollection* m_theInstance;

		std::list<CDICE_Report> m_reports;

	public:
		~CDICE_ReportCollection(void);
		static CDICE_ReportCollection* GetInstance(void);

		bool deleteReports (void);
		bool addReport (DICE_INTERFACE::CDICE_Message msg, long IDmessages, long IDlocations, long IDsystem);
		std::list<DICE_INTERFACE::CDICE_Message> getMatchingReports(std::list<long> messagesIDs, std::list<long> locationsIDs, std::list<long> systemIDs);
		std::list<DICE_INTERFACE::CDICE_Message> getMatchingReports(long messagesID, long locationsID, long systemID);

		bool save (std::ofstream &file);
		bool load (std::ifstream &file);
	};

}//end of namespace DICE_BACK