/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#pragma once
#include "afxcmn.h"
#include "DICE_interface.h"
#include <list>
#include <vector>

namespace DICE_GUI
{

	class CDICE_ReportListWin :
		public CListCtrl
	{
	private:
		CDICE_ReportListWin(void);
		static CDICE_ReportListWin* m_theInstance;

	protected:
		CImageList* m_pImageList;
		std::list<DICE_INTERFACE::CDICE_Message*> m_reports;

		//state for sorting
		//is used in a static function thus has to be static as well !!!
		static std::list<int> m_appliedSorts; //stores what sorting was used
		static std::vector<bool> m_sortStates; //stores wheter reverse of forward sorting was used last
		static const int m_cNumColumns;

		//stupid string to wstring conversion ...
		std::wstring string2wstring (std::string);

		//callback for sorting ....
		static int CALLBACK SortFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);

	public:
		~CDICE_ReportListWin(void);
		static CDICE_ReportListWin* GetInstance ();

		void setReports(std::list<DICE_INTERFACE::CDICE_Message> reports);

		//=============================================
		//        Windows Event and Mesage Stuff
		//=============================================

		// Message maps
		DECLARE_MESSAGE_MAP()

		// Dispatch maps
		DECLARE_DISPATCH_MAP()

		// Dispatch and event IDs
	public:
		enum {
		};
		afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
		afx_msg void OnHdnItemchanged(NMHDR *pNMHDR, LRESULT *pResult);
		afx_msg void OnLvnItemActivate(NMHDR *pNMHDR, LRESULT *pResult);
		afx_msg void OnLvnGetdispinfo(NMHDR *pNMHDR, LRESULT *pResult);
		afx_msg void OnSize(UINT nType, int cx, int cy);
		afx_msg void OnHdnItemclick(NMHDR *pNMHDR, LRESULT *pResult);
		afx_msg void OnNMClick(NMHDR *pNMHDR, LRESULT *pResult);
		afx_msg void OnLvnKeydown(NMHDR *pNMHDR, LRESULT *pResult);
		afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
		afx_msg void OnContextMenu(CWnd* /*pWnd*/, CPoint /*point*/);
		afx_msg void OnHdnEndtrack(NMHDR *pNMHDR, LRESULT *pResult);
		afx_msg void OnHdnTrack(NMHDR *pNMHDR, LRESULT *pResult);
	};
		
} //end of namespace DICE_GUI