/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#pragma once

#include "DICE_DataItem.h"
#include <string>

namespace DICE_BACK
{

	class CDICE_TreeDataBase
	{
	protected:
		CDICE_TreeDataBase(void);

		CDICE_DataItem* m_tree;
		long m_nextID;

	public:
		~CDICE_TreeDataBase(void);

		long convertDescToID (std::string desc);
		long convertDescToID (long parent,std::string desc);
		long addNewLeaf (std::string desc, long parentID, bool *out_pWasPresent);
		long addNewNode (std::string desc, long parentID, bool *out_pWasPresent);
		bool addLink (long itemID, long locationsID, long systemID, double severity);
		bool deleteTree (void);
		std::list<SDICE_LinkType> collectLinksForSelection(long selection);
		std::list<long> collectIDsBySelection(long selection);
		DICE_INTERFACE::CDICE_TreeItem* createFullInterfaceTree (void);
		DICE_INTERFACE::CDICE_TreeItem* createWeightedInterfaceTree (std::list<std::pair<long,double> > weights);
		bool save (std::ofstream &file);
	    bool load (std::ifstream &file);
		bool isEmpty (void);
	};

} //end of namespace DICE_BACK