/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#pragma once

#include <string>

namespace DICE_INTERFACE
{

	class CDICE_TreeItem
	{
	protected:
		CDICE_TreeItem* m_father;
		std::string m_desc;
		double m_severity;
		long m_DICE_id;

	public:
		CDICE_TreeItem(void);
		CDICE_TreeItem(CDICE_TreeItem* father, std::string desc, double severity, long DICE_id);
		~CDICE_TreeItem(void);

		CDICE_TreeItem* getFather (void);
		void setFather (CDICE_TreeItem*);
		std::string getDesc (void);
		void setDesc (std::string);
		double getSeverity (void);
		void setSeverity (double);
		long getDICEid (void);
		void setDICEid (long);

		virtual bool isLeaf (void) = 0;
		virtual double accumulateSeverities (void);
		virtual CDICE_TreeItem* findDICEid (long DICE_id);
	};

} //end of namespace DICE_INTERFACE