/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#pragma once
#include "dice_treeitem.h"
#include <list>

namespace DICE_INTERFACE
{

	class CDICE_TreeNode : public CDICE_TreeItem
	{
	private:
		std::list<CDICE_TreeItem*> m_childs;

	public:
		CDICE_TreeNode(void);
		CDICE_TreeNode(CDICE_TreeItem* father, std::string desc, double severity, long DICE_id);

		~CDICE_TreeNode(void);

		std::list<CDICE_TreeItem*> getChilds (void);
		void addChild (CDICE_TreeItem* child);

		bool isLeaf (void);
		double accumulateSeverities (void);
		CDICE_TreeItem* findDICEid (long DICE_id);
	};

} //end of namespace DICE_INTERFACE