/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#pragma once

#include "guiupdater.h"
#include "DICE_Interface.h"

namespace DICE_GUI
{

	class CDICE_GUIUpdaterWin :
		public DICE_INTERFACE::IDICE_GUIUpdater
	{
	private:
		CDICE_GUIUpdaterWin(void);

		static CDICE_GUIUpdaterWin* m_theInstance;

		DICE_INTERFACE::IDICE_QueryDice* m_queryDICE;

	public:
		~CDICE_GUIUpdaterWin(void);

		static CDICE_GUIUpdaterWin* GetInstance (void);

		/**
		 * This class will store a pointer to a IDICE_QueryDice implementation.
		 * setQueryDICE has to be called before any meaningfull operation is done !!
		 */
		void setQueryDICE (DICE_INTERFACE::IDICE_QueryDice*);
		DICE_INTERFACE::IDICE_QueryDice* getQueryDICE (void);

		/**
		 * @param tree the new content represented as CDICE_TreeItem
		 *        if implementation needs the tree for further usage 
		 *        it must create a copy of the tree.
		 *        (The pointer might not be valid after this call is 
		 *         finished)
		 */
		bool updateMessages (DICE_INTERFACE::CDICE_TreeItem *tree);
		bool updateLocations (DICE_INTERFACE::CDICE_TreeItem *tree);
		bool updateSystem (DICE_INTERFACE::CDICE_TreeItem *tree);
		bool updateReportList (std::list<DICE_INTERFACE::CDICE_Message> reports);
	};

} //end of namespace DICE_GUI