/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#ifndef EXETHREAD_H
#define EXETHREAD_H

#include <QThread>

/*!
 This class is used for running the executable
 */
class ExeThread : public QThread
{
	Q_OBJECT

	public:
		ExeThread(QObject *parent = 0);
		~ExeThread();
		/*!
		 cancel the execution
		 */
		void cancel();
		/*!
		 starts the execution
		 \param command the command to be executed
		 */
		void runexe(QString command);
	signals:
		/*!
		 this signal is emitted when the execution has finished
		 \param ret the return value of the command
		 */
		void commanddone(int ret);

	protected:
		/*!
		 the thread's run function
		 */
		void run();

	private:
		/*!
		 holds the command to be executed
		 */
		QString m_command;
		/*!
		 is set to true when @see cancel() is called
		 */
		bool m_abort;	
};
#endif
