/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#ifndef SERVERTHREAD_H
#define SERVERTHREAD_H

#include <QThread>
#include "SocketLib.h"


class ServerThread : public QThread
{
	Q_OBJECT

	public:
		ServerThread(QObject *parent = 0);
		~ServerThread();
		/*!
		 cancels the Server thread
		 */
		void cancel();
		/*!
		 starts the server thread
		 \param port the port the server listens on
		 */
		bool listen(int port);
	signals:
		/*!
		 sends a message to the GUI
		 \param message the message to be sent
		 */
		void NewMessage(QString message);
		/*!
		 signals the GUI that the client is connected
		 */
		void sconnected();
		/*!
		 signals the GUI that the client is disconnected
		 */
		void sdisconnected();


	protected:
		/*!
		 the thread's run function
		 */
		void run();

	private:
    
    void resetSockets();

		/*!
		 the port the server listens on
		 */
		int m_port;	
		/*!
		 indicates that the server should be stopped
		 */
		bool m_abort;

    CTcpSocket *m_serversocket;
    CTcpSocket *m_channel; 
};
#endif
