package de.hlrs.marmoclipse.log.ui;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.Viewer;

import de.hlrs.marmoclipse.log.MarmotLog;
import de.hlrs.marmoclipse.log.MarmotLogList;

/**
 * provides the log model to the table viewer
 * 
 * @author peng
 *
 */
public class LogContentProvider implements IStructuredContentProvider,
	ILogListViewer {
	private TableViewer logViewer;
	private MarmotLogList logs;

	public LogContentProvider(TableViewer viewer, MarmotLogList logs) {
		this.logViewer = viewer;
		this.logs = logs;
	}

	public void addLog(MarmotLog log) {
		logViewer.add(log);
	}

	public void removeLog(MarmotLog log) {
		logViewer.remove(log);
	}

	public void updateLog(MarmotLog log) {
		logViewer.update(log, null);
	}

	public void clearLogs() {
		logViewer.refresh();
	}

	public Object[] getElements(Object inputElement) {
		return logs.getLogs().toArray();
	}

	public void dispose() {
		logs.removeChangeListener(this);
	}

	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		if (newInput != null)
			((MarmotLogList) newInput).addChangeListener(this);
		if (oldInput != null)
			((MarmotLogList) oldInput).removeChangeListener(this);
	}
}
