package de.hlrs.marmoclipse.log.ui;

import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.ColumnViewer;
import org.eclipse.jface.viewers.EditingSupport;

import de.hlrs.marmoclipse.log.MarmotLog;

/**
 * provides cell editing support, major purpose is to make 
 * the link displayed in the “Reference” column clickable
 * 
 * @author peng
 *
 */
public class LogEditingSupport extends EditingSupport {
	private int column;
	private TableViewer viewer;

	public LogEditingSupport(ColumnViewer viewer, int column) {
		super(viewer);
		this.column = column;
		this.viewer = (TableViewer) viewer;
	}

	@Override
	protected boolean canEdit(Object element) {
		switch (column) {
		case 9:
			return true;
		default:
			break;
		}
		return false;
	}

	@Override
	protected CellEditor getCellEditor(Object element) {
		switch (column) {
		case 9:
			return new ReferenceCellEditor(viewer.getTable());
		default:
			break;
		}
		return null;
	}

	@Override
	protected Object getValue(Object element) {
		MarmotLog log = (MarmotLog) element;
		switch (column) {
		case 9:
			return log.getReference();
		default:
			break;
		}
		return null;
	}

	@Override
	protected void setValue(Object element, Object value) {
		MarmotLog log = (MarmotLog) element;
		switch (column) {
		case 9:
			log.setReference(String.valueOf(value));
		default:
			break;
		}
		getViewer().update(element, null);
	}

}
