package de.hlrs.marmoclipse.log.ui;

import java.util.Arrays;
import org.eclipse.jface.viewers.*;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.*;

import de.hlrs.marmoclipse.log.MarmotLog;
import de.hlrs.marmoclipse.log.MarmotLogList;

@Deprecated
public class LogTableViewer {

	private Table table;
	private TableViewer tableViewer;
	public static MarmotLogList logList = new MarmotLogList();
	// private LogSocketListener socketListener;

	private static final String COLUMN_TIME = "Time";
	private static final String COLUMN_RANK = "Rank";
	private static final String COLUMN_THREAD = "Thread";
	private static final String COLUMN_TYPE = "";
	private static final String COLUMN_MESSAGE = "Message";
	private static final String COLUMN_FILE = "File";
	private static final String COLUMN_LINE = "Line";
	private static final String COLUMN_CALL = "Call";
	private static final String COLUMN_LOCATION = "Location";
	private static final String COLUMN_REFERENCE = "MPI Reference";
	private static final String COLUMN_11 = "11";

	private String[] columnNames = new String[] { COLUMN_TIME, COLUMN_RANK,
		COLUMN_THREAD, COLUMN_TYPE, COLUMN_MESSAGE, COLUMN_FILE, COLUMN_LINE,
		COLUMN_CALL, COLUMN_LOCATION, COLUMN_REFERENCE, COLUMN_11 };

	public LogTableViewer(Composite parent) {
		// logList = new MarmotLogList();
		// socketListener = new LogSocketListener(30777, logList);
		this.addChildControls(parent);
	}

	private void addChildControls(Composite parent) {
		createTable(parent);
		createTableViewer();
		tableViewer.setContentProvider(new LogContentProvider());
		tableViewer.setLabelProvider(new LogLabelProvider());
		tableViewer.setInput(logList);
	}

	private void createTable(Composite parent) {
		// TODO Auto-generated method stub
		int style = SWT.SINGLE | SWT.BORDER | SWT.H_SCROLL | SWT.V_SCROLL
			| SWT.FULL_SELECTION | SWT.HIDE_SELECTION | SWT.VIRTUAL;
		table = new Table(parent, style);
		table.setLinesVisible(true);
		table.setHeaderVisible(true);

		TableColumn column = new TableColumn(table, SWT.LEFT, 0);
		column.setText(COLUMN_TYPE);
		column.setWidth(20);

		column = new TableColumn(table, SWT.LEFT, 1);
		column.setText(COLUMN_TIME);
		column.setWidth(40);

		column = new TableColumn(table, SWT.LEFT, 2);
		column.setText(COLUMN_RANK);
		column.setWidth(60);

		column = new TableColumn(table, SWT.LEFT, 3);
		column.setText(COLUMN_THREAD);
		column.setWidth(60);

		column = new TableColumn(table, SWT.LEFT, 4);
		column.setText(COLUMN_MESSAGE);
		column.setWidth(300);

		column = new TableColumn(table, SWT.LEFT, 5);
		column.setText(COLUMN_FILE);
		column.setWidth(40);

		column = new TableColumn(table, SWT.LEFT, 6);
		column.setText(COLUMN_LINE);
		column.setWidth(50);

		column = new TableColumn(table, SWT.LEFT, 7);
		column.setText(COLUMN_CALL);
		column.setWidth(50);

		column = new TableColumn(table, SWT.LEFT, 8);
		column.setText(COLUMN_LOCATION);
		column.setWidth(70);

		column = new TableColumn(table, SWT.LEFT, 9);
		column.setText(COLUMN_REFERENCE);
		column.setWidth(120);

		column = new TableColumn(table, SWT.LEFT, 10);
		column.setText(COLUMN_11);
		column.setWidth(20);

	}

	private void createTableViewer() {
		tableViewer = new TableViewer(table);
		tableViewer.setUseHashlookup(true);
		tableViewer.setColumnProperties(columnNames);
	}

	public class LogContentProvider implements ILogListViewer,
		IStructuredContentProvider {

		public void addLog(MarmotLog log) {
			tableViewer.add(log);
		}

		public void removeLog(MarmotLog log) {
			tableViewer.remove(log);
		}

		public void updateLog(MarmotLog log) {
			tableViewer.update(log, null);
		}

		public void clearLogs() {
			tableViewer.refresh();
		}

		public Object[] getElements(Object inputElement) {
			return logList.getLogs().toArray();
		}

		public void dispose() {
			logList.removeChangeListener(this);
		}

		public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
			if (newInput != null)
				((MarmotLogList) newInput).addChangeListener(this);
			if (oldInput != null)
				((MarmotLogList) oldInput).removeChangeListener(this);
		}
	}

	public java.util.List<String> getColumnNames() {
		return Arrays.asList(columnNames);
	}

	public ISelection getSelection() {
		return tableViewer.getSelection();
	}

	public MarmotLogList getLogList() {
		return logList;
	}

	public Control getControl() {
		return table.getParent();
	}

	public void startListen() {
		// new Thread(socketListener).start();
		// Display display = this.getControl().getDisplay();
		// Display.getCurrent();
		// Display display = Display.getDefault();
		// if (!display.isDisposed())
		// display.asyncExec(socketListener);
		// socketListener.run();

		// socketListener.schedule();
	}

}
