package de.hlrs.marmoclipse.log.ui;

import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;

import de.hlrs.marmoclipse.log.MarmotLog;

/**
 * support basic filtering functionality
 * 
 * @author peng
 *
 */
public class LogViewerFilter extends ViewerFilter {
	boolean showInfo;
	boolean showWarning;
	boolean showError;
	boolean showNote;
	
	public LogViewerFilter () {
		super();
		showInfo = true;
		showWarning = true;
		showError = true;
		showNote = true;
	}

	public void setShowInfo(boolean showInfo) {
		this.showInfo = showInfo;
	}

	public void setShowWarning(boolean showWarning) {
		this.showWarning = showWarning;
	}

	public void setShowError(boolean showError) {
		this.showError = showError;
	}

	public void setShowNote(boolean showNote) {
		this.showNote = showNote;
	}

	@Override
	public boolean select(Viewer viewer, Object parentElement, Object element) {
		MarmotLog log = (MarmotLog) element;
		if (Integer.valueOf(log.getType()) == MarmotLog.TYPE_INFO)
			return showInfo;
		if (Integer.valueOf(log.getType()) == MarmotLog.TYPE_WARNING)
			return showWarning;
		if (Integer.valueOf(log.getType()) == MarmotLog.TYPE_ERROR)
			return showError;
		if (Integer.valueOf(log.getType()) == MarmotLog.TYPE_NOTE)
			return showNote;
		return true;
	}

}
