#!/bin/sh
echo "Building the Marmot C examples"
MARMOTCC=`which marmotcc`
if [ "$MARMOTCC" = "" ]
then
	echo "No marmotcc in PATH. Exiting"
	exit 1
fi
echo "marmotcc is $MARMOTCC"
for e in `ls *.c`;
do
	EXE_NAME=`echo $e|sed -e "s/\.c//"`
	EXE_NAME=${EXE_NAME}_m
	echo -n "Building $EXE_NAME ..."
	marmotcc -o $EXE_NAME $e
	if [ $? -ne 0 ]
	then
		echo "Could not build $EXE_NAME. Exiting"
		exit 2
	fi
done

