/**
 *  @file
 *
 *  Simple test program.
 *  It just calls 
 *  - MPI_Init
 *  - MPI_Finalize 
 *  - MPI_Comm_rank
 *  - MPI_Comm_size
 *  - MPI_Send_init
 *  - MPI_Start
 *  - MPI_Cancel
 *  - MPI_Test_cancel
 *  - MPI_Wait
 *  - MPI_Request_free
 *
 *  @author Bettina Krammer, Katrin Bidmon, Matthias Mueller
 *
 *  $Id: cancel.c 319 2004-08-16 11:25:02Z rusbetti $  
 */


#include <stdio.h>
#include <assert.h>
#include "mpi.h"

int main(int argc, char **argv)
{
    const int COUNT = 1;
    const int MSG_TAG = 17;

    int size = -1;
    int rank = -1;
    int value = 37;
    int flag = 0;

    MPI::Status status;
    MPI::Prequest prequest;

    MPI::Init(argc, argv);
    size=MPI::COMM_WORLD.Get_size();
    rank=MPI::COMM_WORLD.Get_rank();
    printf(" I am rank %d of %d PEs\n", rank, size);


    if (rank == 1)
    {
        /* going to send message */
        prequest=MPI::COMM_WORLD.Send_init(&value, COUNT, MPI::INT, 0, MSG_TAG);
        prequest.Start();
        prequest.Cancel();
        prequest.Wait(status);
        flag=status.Is_cancelled();
        if (0 != flag)
        {
            printf(" msg cancelled \n");
        }
        prequest.Free();
    }

    MPI::Finalize();

    return 0;
}
