/**
 *  @file
 *
 *  This program is a very simple MPI program to verify that the 
 *  library works correctly.
 *
 *  It just calls 
 *  - MPI_Init
 *  - MPI_Finalize 
 *  - MPI_Comm_rank
 *  - MPI_Comm_size
 *  - MPI_Comm_group
 *  - MPI_Group_incl
 *  - MPI_Group_excl
 *  - MPI_Comm_create
 *
 *  @author Bettina Krammer, Katrin Bidmon, Matthias Mueller
 *
 *  $Id: comm-create-f.c 319 2004-08-16 11:25:02Z rusbetti $  
 */


#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include "mpi.h"

int main(int argc, char **argv)
{
    int size = -1;
    int rank = -1;
    int num = 0;
    int *ranks = 0;
    int i = 0;

    MPI::Intracomm lowcomm;
    MPI::Intracomm falsecomm;

    MPI::Group worldgroup;
    MPI::Group lowgroup;
    MPI::Group uppergroup;

    printf("We call Comm_create twice:\n");
    printf(" 1: correctly, 2: ranks of old comm and group are distinct \n");
    MPI::Init(argc, argv);
    size=MPI::COMM_WORLD.Get_size();
    rank=MPI::COMM_WORLD.Get_rank();

    num = size / 2;
    ranks = (int *) malloc(num * sizeof(MPI::INT));    
/*     printf("num: %d \n", num); */
    for (i = 0; i < num; i++)
    {
        ranks[i] = i;

    }

    printf(" I am rank %d of %d PEs \n", rank, size);

    worldgroup=MPI::COMM_WORLD.Get_group();
    //MPI_Group_incl(worldgroup, num, ranks, &lowgroup);
    lowgroup=worldgroup.Incl(num, ranks);
    //MPI_Group_excl(worldgroup, size - num, ranks, &uppergroup);
    uppergroup=worldgroup.Excl(size-num, ranks);
    //MPI_Comm_create(MPI_COMM_WORLD, lowgroup, &lowcomm);
    lowcomm=MPI::COMM_WORLD.Create(lowgroup);

    if (lowcomm != MPI::COMM_NULL)
    {
        //MPI_Comm_create(lowcomm, uppergroup, &falsecomm);
	falsecomm==lowcomm.Create(uppergroup);
    }

    free(ranks);

    MPI::Finalize();

    return 1;
}
