/**
 *  @file
 *
 *  This program is a very simple MPI program to verify that the 
 *  library works correctly.
 *
 *  It just calls 
 *  - MPI_Init
 *  - MPI_Finalize 
 *  - MPI_Comm_rank
 *  - MPI_Comm_size
 *  - MPI_Comm_group
 *  - MPI_Group_excl
 *
 *  @author Bettina Krammer, Katrin Bidmon, Matthias Mueller
 *
 *  $Id: group-exclude-f.c 319 2004-08-16 11:25:02Z rusbetti $  
 */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "mpi.h"

int main(int argc, char **argv)
{
    int size = -1;
    int rank = -1;
    int num = 0;
    int *ranks = 0;
    int i = 0;

    MPI::Group worldgroup;
    MPI::Group newgroup;

    printf(" Here we use a non-existing rank \n");
    MPI::Init(argc, argv);
    size=MPI::COMM_WORLD.Get_size();
    rank=MPI::COMM_WORLD.Get_rank();

    num = size / 2;
    ranks = (int *) malloc(num * sizeof(MPI::INT));

    for (i = 0; i <= num - 2; i++)
    {
        ranks[i] = i;
    }
    ranks[num - 1] = size;

    printf(" I am rank %d of %d PEs\n", rank, size);

    worldgroup=MPI::COMM_WORLD.Get_group();
    newgroup=worldgroup.Excl(num, ranks);
    /* MPI_Comm_create(comm_cart, worldgroup, &newcomm); */
    /* MPI_Comm_create(MPI_COMM_WORLD, worldgroup, &newcomm); */

    free(ranks);

    MPI::Finalize();

    return 1;
}
