/**
 *  @file
 *
 *  This program is a very simple MPI program to verify that the 
 *  library works correctly.
 *
 *  It just calls 
 *  - MPI_Init
 *  - MPI_Finalize 
 *  - MPI_Comm_rank
 *  - MPI_Comm_size
 *  - MPI_Sendrecv_replace
 *
 *  @author Bettina Krammer, Katrin Bidmon, Matthias Mueller
 *
 *  $Id: sendrecv_replace.c 319 2004-08-16 11:25:02Z rusbetti $  
 */


#include <stdio.h>
#include <assert.h>
#include "mpi.h"

int main(int argc, char **argv)
{
    const int COUNT = 1;
    const int MSG_TAG = 17;

    int size = -1;
    int rank = -1;
    int buf1 = -1;
    int dest = -1;
    int src = -1;

    MPI::Status status;


    MPI::Init(argc, argv);
    size=MPI::COMM_WORLD.Get_size();
    rank=MPI::COMM_WORLD.Get_rank();
    printf(" I am rank %d of %d PEs\n", rank, size);

    dest = (rank + 1) % size;
    src = (rank - 1 + size) % size;
    buf1 = rank;
    //MPI_Sendrecv_replace(&buf1, COUNT, MPI_INT, dest, MSG_TAG, src, MSG_TAG,
                //         MPI_COMM_WORLD, &status)
    MPI::COMM_WORLD.Sendrecv_replace(&buf1, COUNT, MPI::INT, dest, MSG_TAG, src, MSG_TAG);
    assert(buf1 == src);

    MPI::Finalize();

    return 0;
}
